# Licensing

To use Sencha Desktop Packager, you must obtain a license. There are two types of licenses:

- [**Evaluation License**](#!/guide/licensing-section-1)
- [**Full License**](#!/guide/licensing-section-2)

Both forms of the license require a valid Sencha Forum account. If you
do not already have an account, you can register at the link below:

[Register at Sencha Forum](http://www.sencha.com/forum/register.php)

## Evaluation License

An evaluation license entitles you to use Sencha Desktop Packager for 30
days to see if it meets your needs. Applications packaged with an evaluation
license are fully functional, but will only work for 14 days from when
they are packaged, and will have the text, <i>[built using a trial of Sencha Desktop Packager, expiring on MM/DD/YYYY]</i> added to the window title indicating
that they were created with an evaluation license.

At any time during the evaluation period, you can upgrade to full license by
following the instructions in the section
[**Full License**](#!/guide/licensing-section-2) below.

Once you have a Sencha Forum account, you can obtain an Evaluation License
for Sencha Desktop Packager by running <tt>ionpackage</tt> from the
command line.

The first time you run <tt>ionpackage</tt> it will not find a license,
and so it will print a message and prompt for user name and password:

<pre>
Welcome to the Sencha Desktop Packager!

Since you are running the Desktop Packager for the first time,
we need to retrieve your license information.
You will need to supply your Sencha credentials.
If you do not have a Sencha account yet, please register at
http://www.sencha.com/forum/register.php.

Username: johndoe
Password:

If you have received the activation code, please type the code and press Enter.
Otherwise, press Enter to begin your 30 day evaluation.

Activation Code:
</pre>
As the instructions say, just hit enter when it prompts for an activation code and you will receive an evaluation license.

You will not have to resubmit your credentials every time you use
Sencha Desktop Packager with an Evaluation License, but you will see a
reminder message each time you run it:

<pre>
NOTE: You are currently evaluating Sencha Desktop Packager 1.1.
Your evaluation period will end in 26 days.

Applications packaged using this evaluation edition will function
for 14 days from the date it was packaged.

Visit http://www.sencha.com/contact for more information.
</pre>

If you continue using <tt>ionpackage</tt> after the evaluation period is
ended, you will see a message similar to the one below, and will no
longer be able to use <tt>ionpackage</tt> to package applications.

<pre>
NOTE: You are currently evaluating Sencha Desktop Packager 1.1.
Your evaluation has expired. This evaluation expired 11 days ago.

Visit http://www.sencha.com/contact for more information.
</pre>

**NOTE**: The license file is stored in the following location:

- Microsoft Windows: `C:\Users\<username>\AppData\Local\Sencha\Desktop Packager`
- Mac OS X: `~/Library/Application Support/Sencha/Desktop Packager/`
- Linux: `~/.local/share/Sencha/Desktop Packager`

## Full License

Once you have received your activation key, you can run
<tt>ionpackage</tt> with the argument <tt>--activate</tt>, and you will be
prompted for your user name, password and the activation key.

<pre>
> ionpackage --activate
</pre>

You can also enter your activation code directly on the command line as shown below:

<pre>
> ionpackage --activate=ACTIVATION-KEY-FROM-EMAIL
</pre>

where <tt>ACTIVATION-KEY-FROM-EMAIL</tt> should be replaced with the activation
key from the email you recieved.

You only have to enter the activation credentials one time.

### Using Sencha Desktop Packager With Unattended Build Systems

A Sencha Desktop Packager license is tied to a Forum user account, but
the generated license file can only be used on the machine where it
was created. In other words, once you activate a full license with
your Sencha Forum credentials, you can use that license on any
machine, but you need to regenerate the license file for each machine.

This means that if you have a build environment where builds are run
on multiple machines (real or virtual) each machine needs to have its
own license file generated.

In some systems, the entire build environment is generated each time a
build is run. For these environments, we provide the
<tt>--username</tt> and <tt>--password</tt> command line
parameters:

<pre>
> ionpackage --username=john@company.com --password=secret --activate=12345 ...
</pre>

When used with these options, <tt>ionpackage</tt> will
generate a new license file. Note that a network connection will be
required to validate the credentials.
