# Release Notes

## Version 1.1.1

### General Improvements and Fixes

#### All Platforms
- Fixed the handling of URL containings references
- Fixed possible crash due to byte misalignment in the package header
- Fixed possible failure of loading URLs with multiple separators

#### Microsoft Windows
- Added the support for proxy server authorization dialog
- Fixed incorrect path handling in ionpackage tool
- Fixed potential crash due to memory error when using io.watchPath
- Fixed possible failure in loading automatic proxy configuration script

#### Apple Mac OS X
- Fixed possible failure in Ion.ion.unzip
- Fixed potential crash when using Cmd+Q to quit
- Fixed OpenGL errors on mirrored external display
- Fixed possible crash when using file dialogs

#### Linux
- Added the support for proxy server authorization dialog
- Fixed missing path watcher notification of newly created files
- Fixed problem of closing the main window

## Version 1.1

### General Improvements and Fixes
- Updated to Chromium 22 code base
- Linux version (compatible with Ubuntu 10.04 or newer)
- Allow HTML editing (cut, copy, paste) on input fields
- Ion.io.zip and Ion.io.unzip stream large data files to improve performance and memory consumption
- Improved HTML5 Audio and Video support on Windows<br/>Supported media containers are Ogg (Vorbis audio, Theora video) and WebM
- Activated support for Retina display on Mac OS X
- Ensure application window raises to the top when created
- Properly show multi-shortcut keyboard sequences for menu items on Mac OS X
- Menu items beginning with text "About." and "Preferences." get special treatment on Mac OS X (see Ion.ui.Menu.addMenuItem)
- New license model

### New APIs
- Ion.io.canonicalizePath (`function`)
- Ion.io.pathChanged (`event`)
- Ion.io.watchPath / Ion.io.unwatchPath (`function`)
- Ion.io.watchedPaths (`property`)
- Ion.io.zip / Ion.io.unzip (`function`)
- Ion.net.hardwareAddresses (`function`)
- Ion.ui.Menu.aboutToShow / Ion.ui.Menu.aboutToHide (`event`)
- Ion.ui.Menu.at / Ion.ui.MenuBar.at (`function`)
- Ion.ui.Menu.indexOf / Ion.uiMenuBar.indexOf (`function`)
- Ion.ui.Menu.length / Ion.ui.MenuBar.length (`property`)
- Ion.ui.Menu.setText / Ion.ui.MenuItem.setText (`function`)
- Ion.ui.Menu.text (`property`)
- Ion.ui.Window.setType (`function`)
- Ion.ui.Window.type (`property`)
- Ion.util.takeScreenshot (`function`)


