var app,
    win = Ion.ui.mainWindow;

function handleExit() {
    return window.confirm('Do you really want to exit?');
}

function newEvent() {
    app.showEditWindow({StartDate: new Date()});
}

function byDay() {
    app.dayView();
}

function byWeek() {
    app.weekView();
}

function byMonth() {
    app.monthView();
}

function next() {
   app.nextView();
}

function previous() {
    app.previousView();
}

function addMenu() {
    var file, view;
    
    file = win.menuBar.addMenu('File');
    file.addMenuItem('New Event', newEvent, 'Ctrl+N');

    if (Ion.sys.os != 'mac') {
        file.addSeparator();

        var exitKeys = Ion.sys.os == 'windows' ? 'Alt+F4' : 'Ctrl+Q';
        file.addMenuItem('Exit', Ext.bind(win.close, win, []), exitKeys);
    }

    view = win.menuBar.addMenu('View');
    view.addMenuItem('By Day', byDay, 'Shift+D');
    view.addMenuItem('By Week', byWeek, 'Shift+W');
    view.addMenuItem('By Month', byMonth, 'Shift+M');
    view.addSeparator();
    view.addMenuItem('Next', next, 'Right');
    view.addMenuItem('Previous', previous, 'Left');
}

function init() {
    // Ion API to add menus to the application.
    addMenu();

    win.setDimensions(1024, 768);
    win.center();
    win.show();

    win.closing.connect(handleExit);
}
