
Ext.onReady(function () {
    var win = Ion.ui.mainWindow,
        map, infowindow, myLatlng, address, mapwin;

    function init() {
        address = "Redwood City, CA";
        infowindow = new google.maps.InfoWindow();
        Ion.ui.mainWindow.setGeometry(0, 0, 800, 750);
    }

    function handleExit() {
        return window.confirm('Do you really want to exit?');
    }

    function addMenu() {
        function showTraffic() {
            this.geocoder = new google.maps.Geocoder();
            this.geocoder.geocode({ address: address}, function (results, status) {
                if (status === google.maps.GeocoderStatus.OK) {
                    myLatlng = results[0].geometry.location;
                    var myOptions = {
                        zoom: 12,
                        center: myLatlng,
                        mapTypeId: google.maps.MapTypeId.ROADMAP
                    };
                    map = mapwin.down('gmappanel').gmap;
                    var trafficLayer = new google.maps.TrafficLayer();
                    map.setOptions(myOptions);
                    trafficLayer.setMap(map);
                } else {
                    alert("Geocode was not successful for the following reason: " + status);
                }
            });
        }
        
        function bikeLayer() {
            this.geocoder = new google.maps.Geocoder();
            this.geocoder.geocode({ address: address}, function (results, status) {
                if (status === google.maps.GeocoderStatus.OK) {
                    myLatlng = results[0].geometry.location;
                    var myOptions = {
                        zoom: 12,
                        center: myLatlng,
                        mapTypeId: google.maps.MapTypeId.ROADMAP
                    };
                    map = mapwin.down('gmappanel').gmap;
                    map.setOptions(myOptions);
                    var bikeLayer = new google.maps.BicyclingLayer();
                    bikeLayer.setMap(map);
                } else {
                    alert("Geocode was not successful for the following reason: " + status);
                }
            });
        }
        
        function weatherLayer() {
            this.geocoder = new google.maps.Geocoder();
            this.geocoder.geocode({ address: address}, function (results, status) {
                if (status === google.maps.GeocoderStatus.OK) {
                    myLatlng = results[0].geometry.location;
                    var myOptions = {
                        zoom: 12,
                        center: myLatlng,
                        mapTypeId: google.maps.MapTypeId.ROADMAP
                    };
                    map = mapwin.down('gmappanel').gmap;
                    map.setOptions(myOptions);
                    var weatherLayer = new google.maps.weather.WeatherLayer({
                        temperatureUnits: google.maps.weather.TemperatureUnit.FAHRENHEIT
                    });
                    weatherLayer.setMap(map);
                } else {
                    alert("Geocode was not successful for the following reason: " + status);
                }
            });
        }

        function createMarker(place) {
            var placeLoc = place.geometry.location;
            var marker = new google.maps.Marker({
                map: map,
                position: place.geometry.location
            });
            google.maps.event.addListener(marker, 'click', function () {
                infowindow.setContent(place.name);
                infowindow.open(map, this);
            });
        }

        function callback(results, status) {
            if (status === google.maps.places.PlacesServiceStatus.OK) {
                for (var i = 0; i < results.length; i++) {
                    var place = results[i];
                    createMarker(results[i]);
                }
            }
        }

        function searchRestaurants() {
            this.geocoder = new google.maps.Geocoder();
            this.geocoder.geocode({ address: address}, function (results, status) {
                if (status === google.maps.GeocoderStatus.OK) {
                    myLatlng = results[0].geometry.location;
                    var myOptions = {
                        zoom: 12,
                        center: myLatlng,
                        mapTypeId: google.maps.MapTypeId.ROADMAP
                    };
                    var request = {
                        location: myLatlng,
                        radius: '5000',
                        types: ['restaurant']
                    };
                    map = mapwin.down('gmappanel').gmap;
                    map.setOptions(myOptions);
                    service = new google.maps.places.PlacesService(map);
                    service.search(request, callback); 
                } else {
                    alert("Geocode was not successful for the following reason: " + status);
                }
            });
        }

        function searchStore() {
            this.geocoder = new google.maps.Geocoder();
            this.geocoder.geocode({ address: address}, function(results, status) {
                if (status === google.maps.GeocoderStatus.OK) {
                    myLatlng = results[0].geometry.location;
                    var myOptions = {
                        zoom: 12,
                        center: myLatlng,
                        mapTypeId: google.maps.MapTypeId.ROADMAP
                    };
                    var request = {
                        location: myLatlng,
                        radius: '5000',
                        types: ['store']
                    };
                    map = mapwin.down('gmappanel').gmap;
                    map.setOptions(myOptions);
                    service = new google.maps.places.PlacesService(map);
                    service.search(request, callback); 
                } else {
                    alert("Geocode was not successful for the following reason: " + status);
                }
            });
        }

        function clear() {
            this.geocoder = new google.maps.Geocoder();
            this.geocoder.geocode({ address: address}, function (results, status) {
                if (status === google.maps.GeocoderStatus.OK) {
                    myLatlng = results[0].geometry.location;
                    var myOptions = {
                        zoom: 12,
                        center: myLatlng,
                        mapTypeId: google.maps.MapTypeId.ROADMAP
                    };
                    map.setOptions(myOptions); 
                } else {
                    alert("Geocode was not successful for the following reason: " + status);
                }
            });
        }
        
        //add Menu Items  
        var layersMenu, nearbyMenu;
        layersMenu = win.menuBar.addMenu('Layers');
        layersMenu.addMenuItem('Show Traffic', showTraffic);
        layersMenu.addMenuItem('Bike Routes', bikeLayer);
        //layersMenu.addMenuItem('Weather', weatherLayer);
        //layersMenu.addMenuItem('Clear Map', clear);
        layersMenu.addMenuItem('Exit', Ext.bind(win.close, win, []), 'Alt+F4');
        nearbyMenu = win.menuBar.addMenu('Near By');
        nearbyMenu.addMenuItem('Restaurants', searchRestaurants);
        nearbyMenu.addMenuItem('Store', searchStore);
    }
    
    init();
    addMenu();

    //Create the Window and display the map
    mapwin = Ext.create('Ext.window.Window', {
        id: 'GoogleMap',
        autoShow: true,
        layout: {
            type: 'vbox',
            align: 'stretch'
        },
        width:800,
        height:750,
        border: false,
        x: 0,
        y: 0,
        draggable: false,
        closable: false,
        items: [{
            flex:1,
            xtype: 'gmappanel',
            center: {
                geoCodeAddr: 'USA'
            }
        }, {
            xtype: 'textfield',
            name: 'textfield1',
            fieldLabel: 'Search',
            value: address,
            itemId: 'search'
        }, {
            xtype: 'button',
            text : 'Search',
            handler: function () {
                address = mapwin.down('#search').getValue();
                map = mapwin.down('gmappanel').gmap;
                this.geocoder = new google.maps.Geocoder();
                this.geocoder.geocode({ address: address}, function (results, status) {
                    if (status === google.maps.GeocoderStatus.OK) {
                        myLatlng = results[0].geometry.location;
                        var myOptions = {
                            zoom: 12,
                            center: myLatlng,
                            mapTypeId: google.maps.MapTypeId.ROADMAP
                        };
                        map.setOptions(myOptions);
                        map.setCenter(myLatlng); 
                        var marker = new google.maps.Marker({
                            map: map,
                            position: myLatlng
                        });
                    } else {
                        alert("Geocode was not successful for the following reason: " + status);
                    }
                });
            }
        }]
    });

    Ext.EventManager.onWindowResize(function () {
        var w = Ext.getBody().getViewSize().width,
            h = Ext.getBody().getViewSize().height;

        mapwin.setSize(w, h);
    });

    win.setDimensions(1024, 768);
    win.center();
    win.show();

    win.closing.connect(handleExit);
});
