/*
 * File: app/controller/ManifestFileController.js
 *
 * This file was generated by Sencha Architect version 2.2.1.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.1.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.1.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('MyApp.controller.ManifestFileController', {
    extend: 'Ext.app.Controller',

    id: 'fileController',
    views: [
        'MainPanel',
        'ManifestFile'
    ],

    refs: [
        {
            ref: 'ManifestFilePanel',
            selector: '#ManifestFileForm'
        },
        {
            ref: 'MainPanel',
            selector: '#MainPanel'
        }
    ],

    onMainPanelOnFile: function(cmd, eventOptions) {
        switch(cmd) {
            case 'New':
            this.doNew();
            break;
            case 'Open':
            this.doOpen();
            break;
            case 'Save':
            this.doSave();
            break;
            case 'SaveAs':
            this.doSaveAs();
            break;
            case 'Exit':
            this.doExit();
            break;
            default:
            break;
        }
    },

    onMainPanelOnApplication: function(cmd, eventOptions) {
        switch(cmd) {
            case 'Package':
            this.doPackage(true);
            break;
            case 'Run':
            this.doRun();
            break;
            case 'PackageAndRun':
            this.doPackageAndRun();
            break;
            default:
            console.error('OnApplication("'+cmd+'") - Unknown Command');
            break;
        }
    },

    onManifestFileFormDirtyChange: function(basic, dirty, eOpts) {
        this.setWindowTitle();

    },

    onMainPanelOnOpenRecentFile: function(eventOptions) {
        var filePath = eventOptions.path;

        if (Ion.io.pathExists(filePath)) {
            this.openFile(filePath);
        }
        else {
            Ext.Msg.alert('File Not Found', '"'+filePath+'" does not exist.');
        }
    },

    createNewFile: function() {
        // create a blank / default-valued manifest file object
        var defaultValues = {
            organizationName: "My Org",
            applicationName: "My App",
            applicationIconPaths: ["", ""],
            dataDirectoryName: "MyDataDir",
            versionString: "1.0",
            outputPath: "MyAppOut",
            webAppPath: "./",
            settings: {
                security: {
                    allowCrossSite: false,
                    allowFileSystemAccess: false,
                    allowJavascriptClipboardAccess: false
                },
                remoteDebuggingPort:9123,
                mainWindow: {
                    autoShow: true
                }
            },
            encryption: {
                publicKeyPath: "",
                privateKeyPath: ""
            }
        };

        return defaultValues;

    },

    loadFormFromData: function(data) {
        var orgNameField = Ext.getCmp('orgNameField'),
            appNameField = Ext.getCmp('appNameField'),
            versionStringField = Ext.getCmp('versionStringField'),
            appIconWindows = Ext.getCmp('appIconWindows'),
            appIconMac = Ext.getCmp('appIconMac'),
            outputPathField = Ext.getCmp('outputPathField'),
            webAppPathField = Ext.getCmp('webAppPathField'),
            dataDirectoryField = Ext.getCmp('dataDirectoryField'),
            remoteDebuggingPortField = Ext.getCmp('remoteDebuggingPortField'),
            useDebugPortCheckbox = Ext.getCmp('useDebugPortCheckbox'),
            allowCrossSiteCheckbox = Ext.getCmp('allowCrossSiteCheckbox'),
            allowFileSystemAccessCheckbox = Ext.getCmp('allowFileSystemAccessCheckbox'),
            allowJavascriptClipboardAccessCheckbox = Ext.getCmp('allowJavascriptClipboardAccessCheckbox'),
            autoShowWindowCheckbox = Ext.getCmp('autoShowWindowCheckbox'),
            publicKeyPathField = Ext.getCmp('publicKeyPathField'),
            privateKeyPathField = Ext.getCmp('privateKeyPathField'),
            defaultValues = this.createNewFile();

        this.manifestData = data;

        orgNameField.setValue(data.organizationName);
        appNameField.setValue(data.applicationName);
        versionStringField.setValue(data.versionString);
        outputPathField.setValue(data.outputPath);
        webAppPathField.setValue(data.webAppPath);
        dataDirectoryField.setValue(data.dataDirectoryName);

        if (data.settings) {
            if (data.settings.remoteDebuggingPort) {
                useDebugPortCheckbox.setValue(true);
                remoteDebuggingPortField.setValue(data.settings.remoteDebuggingPort);

            }
            else {
                useDebugPortCheckbox.setValue(false);
                if ( ! remoteDebuggingPortField.getValue()) {
                    remoteDebuggingPortField.setValue(defaultValues.settings.remoteDebuggingPort);
                }
            }

            if (data.settings.security) {
                allowCrossSiteCheckbox.setValue(data.settings.security.allowCrossSite);
                allowFileSystemAccessCheckbox.setValue(data.settings.security.allowFileSystemAccess);
                allowJavascriptClipboardAccessCheckbox.setValue(data.settings.security.allowJavascriptClipboardAccess);
            }
            else {
                allowCrossSiteCheckbox.setValue(false);
                allowFileSystemAccessCheckbox.setValue(false);
                allowJavascriptClipboardAccessCheckbox.setValue(false);
            }

            if (data.settings.mainWindow) {
                autoShowWindowCheckbox.setValue(data.settings.mainWindow.autoShow);
            }
            else {
                autoShowWindowCheckbox.setValue(false);
            }        
        }
        else {
            autoShowWindowCheckbox.setValue(false);
            useDebugPortCheckbox.setValue(false);
            remoteDebuggingPortField.setValue(defaultValues.settings.remoteDebuggingPort);
            allowCrossSiteCheckbox.setValue(false);
            allowFileSystemAccessCheckbox.setValue(false);
            allowJavascriptClipboardAccessCheckbox.setValue(false);
        }

        if (data.applicationIconPaths) {
            appIconWindows.setValue(data.applicationIconPaths[0]);
            appIconMac.setValue(data.applicationIconPaths[1]);
        }
        else {
            appIconWindows.setValue('');
            appIconMac.setValue('');
        }

        if (data.encryption) {
            publicKeyPathField.setValue(data.encryption.publicKeyPath || '');
            privateKeyPathField.setValue(data.encryption.privateKeyPath || '');
        }
        else {
            publicKeyPathField.setValue('');
            privateKeyPathField.setValue('');
        }
    },

    getDataFromForm: function() {
        var orgNameField = Ext.getCmp('orgNameField'),
            appNameField = Ext.getCmp('appNameField'),
            versionStringField = Ext.getCmp('versionStringField'),
            appIconWindows = Ext.getCmp('appIconWindows'),
            appIconMac = Ext.getCmp('appIconMac'),
            outputPathField = Ext.getCmp('outputPathField'),
            webAppPathField = Ext.getCmp('webAppPathField'),
            dataDirectoryField = Ext.getCmp('dataDirectoryField'),
            remoteDebuggingPortField = Ext.getCmp('remoteDebuggingPortField'),
            useDebugPort = Ext.getCmp('useDebugPortCheckbox').checked,
            allowCrossSiteCheckbox = Ext.getCmp('allowCrossSiteCheckbox'),
            allowFileSystemAccessCheckbox = Ext.getCmp('allowFileSystemAccessCheckbox'),
            allowJavascriptClipboardAccessCheckbox = Ext.getCmp('allowJavascriptClipboardAccessCheckbox'),
            autoShowWindowCheckbox = Ext.getCmp('autoShowWindowCheckbox'),
            publicKeyPathField = Ext.getCmp('publicKeyPathField'),
            privateKeyPathField = Ext.getCmp('privateKeyPathField');

        this.manifestData.organizationName = orgNameField.getValue();
        this.manifestData.applicationName = appNameField.getValue();
        this.manifestData.versionString = versionStringField.getValue();
        this.manifestData.outputPath = outputPathField.getValue();
        this.manifestData.dataDirectoryName = dataDirectoryField.getValue();
        this.manifestData.webAppPath = webAppPathField.getValue();

        this.manifestData.applicationIconPaths = this.manifestData.applicationIconPaths || [];
        this.manifestData.applicationIconPaths[0] = appIconWindows.getValue();
        this.manifestData.applicationIconPaths[1] = appIconMac.getValue();

        this.manifestData.settings = this.manifestData.settings || {};

        this.manifestData.settings.security = this.manifestData.settings.security || {};

        this.manifestData.settings.security.allowCrossSite = Boolean(allowCrossSiteCheckbox.checked);
        this.manifestData.settings.security.allowFileSystemAccess = Boolean(allowFileSystemAccessCheckbox.checked);
        this.manifestData.settings.security.allowJavaScriptClipboardAccess = Boolean(allowJavascriptClipboardAccessCheckbox.checked);

        if (useDebugPort) {
            this.manifestData.settings.remoteDebuggingPort = remoteDebuggingPortField.getValue();
        }
        else {
            delete this.manifestData.settings.remoteDebuggingPort;
        }

        this.manifestData.encryption = this.manifestData.encryption || {};
        this.manifestData.encryption.publicKeyPath = publicKeyPathField.getValue();
        this.manifestData.encryption.privateKeyPath = privateKeyPathField.getValue();

        return this.manifestData;
    },

    init: function(application) {
        application.currentFilePath = Ion.io.userDocsPath;



        this.control({
            "#MainPanel": {
                onFile: this.onMainPanelOnFile,
                onApplication: this.onMainPanelOnApplication,
                onOpenRecentFile: this.onMainPanelOnOpenRecentFile
            },
            "#ManifestFileForm": {
                dirtychange: this.onManifestFileFormDirtyChange
            }
        });
    },

    setWindowTitle: function() {
        var appName = Ext.getCmp('appNameField').getValue(),
            panel = this.getManifestFilePanel(),
            path = this.currentFilePath,
            isDirty = '',
            title = '';

        if (! path) {
            path = 'New File';
        }

        if (panel.getForm().isDirty()) {
            isDirty = ' *';
        }

        title = appName + " (" + path + ") " + isDirty;
        Ion.ui.mainWindow.setTitle(title);

    },

    doSave: function() {
        var result,
            panel = this.getManifestFilePanel();

        if (! this.currentFilePath ) {
            return this.doSaveAs();
        }
        this.getDataFromForm();

        result = Ion.io.writeFile(this.currentFilePath, JSON.stringify(this.manifestData, null, '  '));

        if (! result.success) {
            Ext.Msg.alert('Save Failed', this.currentFilePath);
        }
        else {
            // mark form as not dirty
            panel.clearDirty();
        }

        this.setWindowTitle();

        return true;

    },

    doSaveAs: function() {
        var result, path, fileName;

        if (this.currentFilePath) {
            path = this.currentFilePath.substring(0, this.currentFilePath.lastIndexOf('/'));
            fileName = this.currentFilePath.substring(this.currentFilePath.lastIndexOf('/') + 1);
        }
        else {
            path = Ion.io.userDocsPath;
            fileName = Ext.getCmp('appNameField').getValue().replace(' ', '').toLowerCase() + 'config.json';
        }

        result = Ion.io.browseFiles(
        {
            path: path,
            type: 'save',
            defaultValue: fileName,
            filters: [ ['JSON Files', '*.json'], ['All Files', '*.*'] ]
        });

        if (!result.success) {
            return false;
        }

        if (Ion.io.pathExists(result.value)) {
            if (! confirm(result.value + " already exists.\nDo you want to overwrite it?")) {
                return false;
            }
        }

        this.setCurrentPath(result.value);
        this.doSave();

        return true;
    },

    doOpen: function() {
        var result,
            path,
            filepath,
            options,
            data;

        if (this.currentFilePath) {
            path = this.currentFilePath.substring(0, this.currentFilePath.lastIndexOf('/'));
        }
        else {
            path = Ion.io.userDocsPath;
        }

        options = {
            path: path,
            type: 'open',
            filters: [['JSON files', '*.json'], ['All Files', '*.*']]
        };
        if (this.currentFilePath) {
            options.defaultValue = this.currentFilePath.substring(this.currentFilePath.lastIndexOf('/') + 1);
        }

        result = Ion.io.browseFiles(options);

        if (! result.success) {
            return;
        }

        this.openFile(result.value);

    },

    doExit: function() {
        var form = this.getManifestFilePanel().getForm();

        if (form.isDirty()) {
            Ext.Msg.show({
                title: "About to Exit", 
                msg: "There are unsaved changes.<br/><br/>Are you sure you want to exit?",
                fn: function(buttonId) {
                    if (buttonId === 'yes') {
                        Ion.app.exit(0);
                    }},
                    buttons: Ext.Msg.YESNO,
                    icon: Ext.window.MessageBox.WARNING
                });
            }
            else {
                Ion.app.exit(0);
            }
    },

    doPackage: function(verbose) {
        var form = this.getManifestFilePanel().getForm(),
            ionpackagePath = Ext.getCmp('ionpackagePathTextField').getValue(),
            runtimePath = Ext.getCmp('runtimePathTextField').getValue(),
            overwrite = Ext.getCmp('overwriteCheckbox').getValue(),
            cmd, output, success = false,
            progress = Ext.Msg.wait('', 'Please Wait', {
                interval: 500, //bar will move fast!
                duration: 50000,
                increment: 15,
                text: 'Packaging...',
                scope: this,
                fn: function(){
                    p.updateText('Done!');
            }
        });
        try {
            if (form.isDirty()) {
                if (! confirm("There are unsaved changes.\n\nSave and continue?")) {
                    Ion.ui.mainWindow.show();
                    return success;
                }
                this.doSave();
            }


            if (Ion.sys.os === 'windows') {
                runtimePath = runtimePath.replace('/', '\\');
            }

            cmd = 'cd ' + runtimePath + ' & ' + ionpackagePath + ' ';
            if (overwrite) {
                cmd += '--overwrite ';
            }
            cmd += this.currentFilePath;

            output = Ion.sys.exec(cmd);

            progress.hide();
            success = output.indexOf('Run-time is extracted') !== -1;

            if (!success || verbose) {
                Ext.Msg.alert(success ? 'Package Successful' : 'Package Failed!', '<pre>'+output+'</pre>');
            }

        }
        catch (err) {
            progress.hide();
            Ext.Msg.alert('ERROR', 
            'Something terrible has happened:<br/><br/><pre>'+err+'</pre>');    
        }

        return success;
    },

    doRun: function() {
        var form = this.getManifestFilePanel().getForm(),
            runtimePath = Ext.getCmp('runtimePathTextField').getValue(),
            outputPath = Ext.getCmp('outputPathField').getValue(),
            appName = Ext.getCmp('appNameField').getValue(),
            cmd = runtimePath + '/' + outputPath + '/' + appName;

        if (Ion.sys.os === 'windows') {
            cmd = cmd + '.exe';
        }
        else if (Ion.sys.os === 'mac') {
            cmd = cmd + '.app/Contents/MacOS/Sencha Ion';
        }

        if (!Ion.io.pathExists(cmd)) {
            Ext.Msg.alert('Error', 'Command does not exist.<br/><br/>Maybe you haven\'t packaged it yet?');
            return false;
        }

        if (Ion.sys.os === 'windows') {
            cmd = cmd.replace(/ /g, '" "');
        }
        else if (Ion.sys.os === 'mac') {
            cmd = cmd.replace(/ /g, '\\ ');
        } 
        else {
            cmd = cmd.replace(/ /g, '" "');
        }

        Ion.ui.mainWindow.hide();

        try {
            Ion.sys.exec(cmd);
        }
        catch (err) {
            Ext.Msg.alert('Error', 'Could not excute command\n'+cmd+'\n\n'+err);
            Ion.ui.mainWindow.show();
            return false;
        }

        Ion.ui.mainWindow.show();

        return true;

    },

    doPackageAndRun: function() {
        if (this.doPackage(false)) {
            this.doRun();
        }

    },

    doNew: function() {
        var fileNameItem,
            me = this;

        if (this.getManifestFilePanel().getForm().isDirty()) {

            Ext.Msg.show({
                title: 'Unsaved Changes',
                msg: 'There are unsaved Changes.<br/>\'Yes\' to save changes,<br/>\'No\' to discard changes<br/>\'Cancel\' to cancel',
                buttonText: {yes: 'Save', no: 'Discard', cancel: 'Cancel'},
                fn: function(btnid, txt, opt) {
                    if (btnid === 'yes') {
                        if (this.doSave()) {
                            this.doNew();
                        }
                    }
                    else if(btnid === 'no') {
                        this.getManifestFilePanel().clearDirty();
                        this.doNew();
                    }
                },
                scope: me,
                icon: Ext.Msg.QUESTION
            });
        }
        else {
            this.setCurrentPath(undefined);    
            this.loadFormFromData(this.createNewFile());
            this.getManifestFilePanel().clearDirty();
            this.setWindowTitle();
        }
    },

    setCurrentPath: function(path) {
        if (path !== this.currentFilePath) {
            this.currentFilePath = path;
            Ext.getCmp('manifestFilePath').setValue(this.currentFilePath);
            this.addRecentFile(this.currentFilePath);
        }
    },

    addRecentFile: function(path) {
        var i = this.recentFileList.indexOf(path),
            mainPanel = this.getMainPanel();

        if (path) {
            if (i !== -1) {
                this.recentFileList.splice(i,1);
            }

            this.recentFileList.unshift(path);

            // make sure all files in the list exist
            i = this.recentFileList.length;
            while (i > 0) {
                i--;
                if (! Ion.io.pathExists(this.recentFileList[i])) {
                    this.recentFileList.splice(i, 1);
                }
            }

            // make sure the list doesn't get crazy long
            // TODO make recentFileListLength a configureable parameter in settings.
            while (this.recentFileList.length > 5) {
                this.recentFileList.pop();
            }

            localStorage.recentFileList = JSON.stringify(this.recentFileList);

            mainPanel.updateRecentFileMenu(this.recentFileList);
        }
    },

    openFile: function(filePath, silent) {
        var result = Ion.io.readFile(filePath),
            panel = this.getManifestFilePanel(),
            data, err;

        if (!result.success) {
            if (!silent) {
                Ext.Msg.alert('Failed to read file', '<br/><br/>' + filePath);
            }
            return false;
        }

        try {
            data = JSON.parse(result.data);
            this.setCurrentPath(filePath);
            this.loadFormFromData(data);
            panel.clearDirty();
            this.setWindowTitle();
        }
        catch (err) {
            if (!silent) {
                Ext.Msg.alert('Unable to load file','<tt>' + err + '</tt>');
            }
            return false;
        }

        return true;
    },

    loadMostRecentFileList: function() {
        var mainPanel = this.getMainPanel(), i = 0;

        if (! this.recentFileList) {
            if (localStorage.recentFileList) {
                this.recentFileList = JSON.parse(localStorage.recentFileList);
            }
            else {
                this.recentFileList = [];
            }
        }

        if (this.recentFileList.length > 0) {
            while(i < this.recentFileList.length) {
                if (this.openFile(this.recentFileList[i], true)) {
                    return;
                }
                i++;
            }
        }

        mainPanel.updateRecentFileMenu(this.recentFileList);

    }

});
