/*
 * File: app/view/MainPanel.js
 *
 * This file was generated by Sencha Architect version 2.2.1.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.1.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.1.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('MyApp.view.MainPanel', {
    extend: 'Ext.tab.Panel',

    requires: [
        'MyApp.view.ManifestFile',
        'MyApp.view.SettingsForm'
    ],

    height: 660,
    id: 'MainPanel',
    itemId: 'MainPanel',
    header: false,
    manageHeight: false,
    activeTab: 0,

    initComponent: function() {
        var me = this;

        me.addEvents(
            'onFile',
            'onApplication',
            'onOpenRecentFile'
        );

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'manifestfile',
                    height: 553,
                    manageHeight: false,
                    trackResetOnLoad: true
                },
                {
                    xtype: 'settingsform',
                    id: 'settingsForm',
                    itemId: 'settingsForm',
                    width: 598
                }
            ]
        });

        me.processMainPanel(me);
        me.callParent(arguments);
    },

    processMainPanel: function(config) {
        this.createMenuBar();
    },

    createMenuBar: function() {
        var me = this,
            mb = Ion.ui.mainWindow.menuBar,
            menu;

        this.menus = {};

        ///// File Menu

        menu = this.menus.File = mb.addMenu('File');
        this.menu_items = {};
        this.menu_items.file_new = menu.addMenuItem('New', function () {me.fireEvent('onFile','New');},'Ctrl+N');
        this.menu_items.file_open = menu.addMenuItem('Open...', function() {me.fireEvent('onFile', 'Open');}, 'Ctrl+O');
        menu.addSeparator();
        this.menu_items.recent_list = menu.addMenu('Recent Files...');
        menu.addSeparator();
        this.menu_items.file_save = menu.addMenuItem('Save', function() {me.fireEvent('onFile', 'Save');}, 'Ctrl+S');
        this.menu_items.file_saveas = menu.addMenuItem('Save As...', function() {me.fireEvent('onFile', 'SaveAs');}, 'Ctrl+Shift+S');
        menu.addSeparator();
        this.menu_items.file_exit = menu.addMenuItem('Exit', function() {me.fireEvent('onFile', 'Exit');});

        ///// Application Menu

        menu = this.menus.Application = mb.addMenu('Application');
        this.menu_items.application_package = menu.addMenuItem('Package', function() {me.fireEvent('onApplication', 'Package');}, 'Ctrl+P');
        this.menu_items.application_run = menu.addMenuItem('Run', function() {me.fireEvent('onApplication', 'Run');}, 'Ctrl+R');
        this.menu_items.application_pack_run = menu.addMenuItem('Package and Run', function() {me.fireEvent('onApplication', 'PackageAndRun');}, 'Ctrl+Shift+R');

        menu = this.menus.Help = mb.addMenu('Help');
        this.menu_items.help_documentation = menu.addMenuItem('View Documentation', function() {me.showDocs();});

    },

    showDocs: function() {
        var ionpackagePath = Ext.getCmp('ionpackagePathTextField').getValue(), 
        docPath = ionpackagePath.substring(0, ionpackagePath.lastIndexOf('/')) + '/docs/index.html';

        if (Ion.sys.os === 'mac') {
            docPath = 'file://localhost' + docPath;
        }

        Ion.util.openUrl(docPath);


    },

    manageMenuBar: function() {
        var ionpackagePathText = Ext.getCmp('ionpackagePathTextField'),
            ionpackagePath = Ext.getCmp('ionpackagePathTextField').getValue(),
            runtimeDirPath = Ext.getCmp('runtimePathTextField').getValue(),
            ionpackageValid = Boolean(ionpackagePath) && Ion.io.pathExists(ionpackagePath),
            runtimeDirValid =  Boolean(runtimeDirPath) && Ion.io.pathExists(runtimeDirPath),
            pathsValid = ionpackageValid && runtimeDirValid,
            docPath;

        // XXX Also need loaded manifest file
        this.menu_items.application_package.setEnabled(pathsValid);
        this.menu_items.application_run.setEnabled(pathsValid);
        this.menu_items.application_pack_run.setEnabled(pathsValid);

        docPath = ionpackagePath.substring(0, ionpackagePath.lastIndexOf('/')) + '/docs/index.html';

        this.menu_items.help_documentation.setEnabled(Ion.io.pathExists(docPath));
    },

    updateRecentFileMenu: function(list) {
        var menu = this.menu_items.recent_list,
            item, path,
            me = this;

        menu.clear();
        createCallback = function (fpath) {
            return function() {me.fireEvent('onOpenRecentFile', {path: fpath});};
        };

        if (list.length > 0) {
            item = 0;
            while (item < list.length) {
                path = list[item];
                menu.addMenuItem(list[item].substring(list[item].lastIndexOf('/') + 1),
                createCallback(list[item]));
                item++;
            }
        }
        else {
            item = menu.addMenuItem('(none)', function(){});
            item.setEnabled(false);
        }
    }

});