/*
 * File: app/view/SettingsForm.js
 *
 * This file was generated by Sencha Architect version 2.2.1.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.1.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.1.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('MyApp.view.SettingsForm', {
    extend: 'Ext.form.Panel',
    alias: 'widget.settingsform',

    height: 130,
    id: 'GeneralSettingsForm',
    itemId: 'GeneralSettingsForm',
    autoScroll: true,
    bodyBorder: false,
    collapseFirst: false,
    frameHeader: false,
    manageHeight: false,
    title: 'General Settings',

    initComponent: function() {
        var me = this;

        me.addEvents(
            'onSettingsChanged'
        );

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'fieldcontainer',
                    margin: '10 10 0 10',
                    layout: {
                        type: 'column'
                    },
                    items: [
                        {
                            xtype: 'textfield',
                            validator: function(value) {
                                if (value === '') {
                                    return "Ionpackage path is required for packaging";
                                }

                                if (!Ion.io.pathExists(value)) {
                                    return "Ionpackage path must point to ionpackage executable";
                                }

                                return true;
                            },
                            columnWidth: 1,
                            id: 'ionpackagePathTextField',
                            itemId: 'ionpackagePathTextField',
                            fieldLabel: 'Ionpackage Path',
                            labelAlign: 'right',
                            validateOnChange: false,
                            inputId: 'IonpackagePathText',
                            readOnly: true,
                            emptyText: 'path to ionpackage executable'
                        },
                        {
                            xtype: 'button',
                            margin: '0 0 0 10',
                            text: 'Set...',
                            listeners: {
                                click: {
                                    fn: me.onButtonClick,
                                    scope: me
                                }
                            }
                        }
                    ]
                },
                {
                    xtype: 'fieldcontainer',
                    margin: '10 10 0 10',
                    layout: {
                        type: 'column'
                    },
                    items: [
                        {
                            xtype: 'textfield',
                            validator: function(value) {
                                if (value === '') {
                                    return "Runtime path is required for packaging & running";
                                }

                                if (!Ion.io.pathExists(value)) {
                                    return "Runtime path must be a valid directory";
                                }

                                return true;
                            },
                            columnWidth: 1,
                            stateEvents: [
                                'change'
                            ],
                            stateId: 'RuntimePath',
                            stateful: true,
                            id: 'runtimePathTextField',
                            itemId: 'runtimePathTextField',
                            fieldLabel: 'Runtime Path',
                            labelAlign: 'right',
                            inputId: 'RuntimePathText',
                            readOnly: true,
                            emptyText: 'path to run ionpackage executable from'
                        },
                        {
                            xtype: 'button',
                            margin: '0 0 0 10',
                            text: 'Set...',
                            listeners: {
                                click: {
                                    fn: me.onButtonClick1,
                                    scope: me
                                }
                            }
                        }
                    ]
                },
                {
                    xtype: 'fieldcontainer',
                    margin: '10 10 10 10',
                    width: 400,
                    autoScroll: true,
                    layout: {
                        type: 'column'
                    },
                    items: [
                        {
                            xtype: 'checkboxfield',
                            stateEvents: [
                                'change'
                            ],
                            stateId: 'Overwrite',
                            stateful: true,
                            id: 'overwriteCheckbox',
                            itemId: 'overwriteCheckbox',
                            fieldLabel: 'Overwrite',
                            labelAlign: 'right',
                            inputId: 'OverwriteCheckbox',
                            boxLabel: ''
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    onButtonClick: function(button, e, eOpts) {
        var result, 
        ionpackagerField = Ext.getCmp('ionpackagePathTextField'),
        path = ionpackagerField.getValue(),
        appFileName = Ion.sys.os === 'windows' ? 'ionpackage.exe' : 'ionpackage',
        filterPattern = Ion.sys.os === 'mac' ? '*' : appFileName,
        browseOptions = {
            type: 'open',
            caption: 'Find ' + appFileName,
            defaultValue: appFileName,
            filters: [{
                name: 'Ion Package Executable',
                pattern: filterPattern
            }]
        };

        if (path && !Ion.io.pathExists(path)) {
            path = '';
        }
        result = Ion.io.browseFiles(browseOptions);

        if (result.success) {
            ionpackagerField.setValue(result.value);
            ionpackagerField.isValid(); // force validation
            this.fireEvent('onSettingsChanged');
        }
    },

    onButtonClick1: function(button, e, eOpts) {
        var result,
            runPathItem = Ext.getCmp('runtimePathTextField'),
            path = runPathItem.getValue(),
            browseOptions = {
                path: path
            };

        result = Ion.io.browseDirectories(browseOptions);

        if (result.success) {
            runPathItem.setValue(result.value);
            runPathItem.isValid(); // force validation
            this.fireEvent('onSettingsChanged');
        }

    },

    setFields: function(settings) {
        var ionpackagerPath = Ext.getCmp('ionpackagePathTextField'),
            rundirPath = Ext.getCmp('runtimePathTextField'),
            overwrite = Ext.getCmp('overwriteCheckbox');

        ionpackagerPath.setValue(settings.ionpackagerPath);
        rundirPath.setValue(settings.rundirPath);
        overwrite.setValue(settings.overwrite);
    },

    getFields: function() {
        var ionpackagerPath = Ext.getCmp('ionpackagePathTextField'),
            rundirPath = Ext.getCmp('runtimePathTextField'),
            overwrite = Ext.getCmp('overwriteCheckbox'),
            settings = {};

        settings.ionpackagerPath = ionpackagerPath.getValue();
        settings.rundirPath = rundirPath.getValue();
        settings.overwrite = overwrite.getValue();

        return settings;
    }

});