var win = Ion.ui.mainWindow,
    filename,
    saveAsMenuItem;

function changeColor() {
    document.getElementById('p1').style.color = 'magenta';
}

function handleExit() {
    return confirm('Do you really want to exit?');
}

function handleOpen() {
    var result, path;

    result = Ion.io.browseFiles({
        caption: 'Load Text File',
        path: filename,
        filters: [['Text Files', '*.txt']],
        type: 'open'
    });

    if (result.success) {
        path = result.value;
        result = Ion.io.readFile(path);
        if (result.success) {
            document.getElementById('txt1').value = result.data;
            saveAsMenuItem.setEnabled(true);
            filename = path;
        }
    }
}

function handleSave() {
    if (filename) {
        var data = document.getElementById('txt1').value;
        Ion.io.writeFile(filename, data);
        saveAsMenuItem.setEnabled(true);
    } else {
        handleSaveAs();
    }
}

function handleSaveAs() {
    var result,
        overwrite = true;

    result = Ion.io.browseFiles({
        caption: 'Save File',
        path: filename,
        filters: [['Text Files', '*.txt']]
    });
    if (result.success) {
        if (Ion.io.pathExists(result.value)) {
            overwrite = confirm('File exists\nOk to overwrite it?');
        }
        if (overwrite) {
            filename = result.value;
            Ion.io.writeFile(filename, document.getElementById('txt1').value);
        }
    }
}

function addMenu() {
    var fileMenu;

    fileMenu = win.menuBar.addMenu('File');
    fileMenu.addMenuItem('Change Color', changeColor);
    fileMenu.addSeparator();
    fileMenu.addMenuItem('Open', handleOpen, 'Ctrl+O');
    fileMenu.addSeparator();

    fileMenu.addMenuItem('Save', handleSave, 'Ctrl+S');
    fileMenu.addSeparator();
    saveAsMenuItem = fileMenu.addMenuItem('Save As', handleSaveAs, 'Ctrl+Shift+S');
    saveAsMenuItem.setEnabled(false);

    if (Ion.sys.os != 'mac') {
        fileMenu.addSeparator();

        var exitKeys = Ion.sys.os == 'windows' ? 'Alt+F4' : 'Ctrl+Q';
        fileMenu.addMenuItem('Exit', function() { win.close(); }, exitKeys);
    }
}

win.setDimensions(1024, 768);
win.center();
win.show();
