Ext.data.JsonP.licensing({"title":"Licensing","guide":"<h1>Licensing</h1>\n<div class='toc'>\n<p><strong>Contents</strong></p>\n<ol>\n<li><a href='#!/guide/licensing-section-1'>Evaluation License</a></li>\n<li><a href='#!/guide/licensing-section-2'>Full License</a></li>\n</ol>\n</div>\n\n<p>To use Sencha Desktop Packager, you must obtain a license. There are two types of licenses:</p>\n\n<ul>\n<li><a href=\"#!/guide/licensing-section-1\"><strong>Evaluation License</strong></a></li>\n<li><a href=\"#!/guide/licensing-section-2\"><strong>Full License</strong></a></li>\n</ul>\n\n\n<p>Both forms of the license require a valid Sencha Forum account. If you\ndo not already have an account, you can register at the link below:</p>\n\n<p><a href=\"http://www.sencha.com/forum/register.php\">Register at Sencha Forum</a></p>\n\n<h2 id='licensing-section-1'>Evaluation License</h2>\n\n<p>An evaluation license entitles you to use Sencha Desktop Packager for 30\ndays to see if it meets your needs. Applications packaged with an evaluation\nlicense are fully functional, but will only work for 14 days from when\nthey are packaged, and will have the text, <i>[built using a trial of Sencha Desktop Packager, expiring on MM/DD/YYYY]</i> added to the window title indicating\nthat they were created with an evaluation license.</p>\n\n<p>At any time during the evaluation period, you can upgrade to full license by\nfollowing the instructions in the section\n<a href=\"#!/guide/licensing-section-2\"><strong>Full License</strong></a> below.</p>\n\n<p>Once you have a Sencha Forum account, you can obtain an Evaluation License\nfor Sencha Desktop Packager by running <tt>ionpackage</tt> from the\ncommand line.</p>\n\n<p>The first time you run <tt>ionpackage</tt> it will not find a license,\nand so it will print a message and prompt for user name and password:</p>\n\n<pre>Welcome to the Sencha Desktop Packager!\n\nSince you are running the Desktop Packager for the first time,\nwe need to retrieve your license information.\nYou will need to supply your Sencha credentials.\nIf you do not have a Sencha account yet, please register at\nhttp://www.sencha.com/forum/register.php.\n\nUsername: johndoe\nPassword:\n\nIf you have received the activation code, please type the code and press Enter.\nOtherwise, press Enter to begin your 30 day evaluation.\n\nActivation Code:\n</pre>\n\n\n<p>As the instructions say, just hit enter when it prompts for an activation code and you will receive an evaluation license.</p>\n\n<p>You will not have to resubmit your credentials every time you use\nSencha Desktop Packager with an Evaluation License, but you will see a\nreminder message each time you run it:</p>\n\n<pre>NOTE: You are currently evaluating Sencha Desktop Packager 1.1.\nYour evaluation period will end in 26 days.\n\nApplications packaged using this evaluation edition will function\nfor 14 days from the date it was packaged.\n\nVisit http://www.sencha.com/contact for more information.\n</pre>\n\n\n<p>If you continue using <tt>ionpackage</tt> after the evaluation period is\nended, you will see a message similar to the one below, and will no\nlonger be able to use <tt>ionpackage</tt> to package applications.</p>\n\n<pre>NOTE: You are currently evaluating Sencha Desktop Packager 1.1.\nYour evaluation has expired. This evaluation expired 11 days ago.\n\nVisit http://www.sencha.com/contact for more information.\n</pre>\n\n\n<p><strong>NOTE</strong>: The license file is stored in the following location:</p>\n\n<ul>\n<li>Microsoft Windows: <code>C:\\Users\\&lt;username&gt;\\AppData\\Local\\Sencha\\Desktop Packager</code></li>\n<li>Mac OS X: <code>~/Library/Application Support/Sencha/Desktop Packager/</code></li>\n<li>Linux: <code>~/.local/share/Sencha/Desktop Packager</code></li>\n</ul>\n\n\n<h2 id='licensing-section-2'>Full License</h2>\n\n<p>Once you have received your activation key, you can run\n<tt>ionpackage</tt> with the argument <tt>--activate</tt>, and you will be\nprompted for your user name, password and the activation key.</p>\n\n<pre>> ionpackage --activate\n</pre>\n\n\n<p>You can also enter your activation code directly on the command line as shown below:</p>\n\n<pre>> ionpackage --activate=ACTIVATION-KEY-FROM-EMAIL\n</pre>\n\n\n<p>where <tt>ACTIVATION-KEY-FROM-EMAIL</tt> should be replaced with the activation\nkey from the email you recieved.</p>\n\n<p>You only have to enter the activation credentials one time.</p>\n\n<h3>Using Sencha Desktop Packager With Unattended Build Systems</h3>\n\n<p>A Sencha Desktop Packager license is tied to a Forum user account, but\nthe generated license file can only be used on the machine where it\nwas created. In other words, once you activate a full license with\nyour Sencha Forum credentials, you can use that license on any\nmachine, but you need to regenerate the license file for each machine.</p>\n\n<p>This means that if you have a build environment where builds are run\non multiple machines (real or virtual) each machine needs to have its\nown license file generated.</p>\n\n<p>In some systems, the entire build environment is generated each time a\nbuild is run. For these environments, we provide the\n<tt>--username</tt> and <tt>--password</tt> command line\nparameters:</p>\n\n<pre>> ionpackage --username=john@company.com --password=secret --activate=12345 ...\n</pre>\n\n\n<p>When used with these options, <tt>ionpackage</tt> will\ngenerate a new license file. Note that a network connection will be\nrequired to validate the credentials.</p>\n"});