Ext.data.JsonP.quick_ref({"title":"Quick Reference","guide":"<h1>Quick Reference</h1>\n<div class='toc'>\n<p><strong>Contents</strong></p>\n<ol>\n<li><a href='#!/guide/quick_ref-section-1'>ionpackage</a></li>\n<li><a href='#!/guide/quick_ref-section-2'>Manifest File</a></li>\n</ol>\n</div>\n\n<h2 id='quick_ref-section-1'>ionpackage</h2>\n\n<pre>Usage: ionpackage [options] configFile.json\n\nOptions:\n   --overwrite       Force overwriting the target path (if it already exists).\n   -h or --help      Display this usage.\n   --username=USER   Specify Sencha Forum user name (for generating license files)\n   --password=PASSWD Specify Sencha Forum password (for generating license files)\n   --activate[=KEY]  Use KEY to activate a full license.\n</pre>\n\n\n<h2 id='quick_ref-section-2'>Manifest File</h2>\n\n<p>The manifest file is JSON file which can be used to define various parameters used in packaging the application.</p>\n\n<div class='entry'>\n<div class='entry-head'>organizationName [string]</div>\n<div class='entry-body'>\nThe name of the organization responsible for the packaged application. This string will be used in <a href=\"#!/api/Ion.io-property-userDataPath\" rel=\"Ion.io-property-userDataPath\" class=\"docClass\">Ion.io.userDataPath</a>.\nIf <tt>organizationName</tt> is omitted, it will default to the value of <tt>applicationName</tt>.\n</div>\n</div>\n\n\n\n\n<div class='entry'>\n<div class='entry-head'>applicationName [string]</div>\n<div class='entry-body'>\nThe name of the application. This will be the name of the executable file generated by <tt>ionpackage</tt>. It is also used in <a href=\"#!/api/Ion.io-property-userDataPath\" rel=\"Ion.io-property-userDataPath\" class=\"docClass\">Ion.io.userDataPath</a>.\n</div>\n</div>\n\n\n\n\n<div class='entry'>\n<div class='entry-head'>outputPath [string]</div>\n<div class='entry-body'>\nThe name of the directory that stores the packaged application. If this is a relative path, it will be relative to where <tt>ionpackage</tt> is called from, i.e. the current working directory.\n</div>\n</div>\n\n\n\n\n<div class='entry'>\n<div class='entry-head'>dataDirectoryName [string]</div>\n<div class='entry-body'>\nThe name of the directory that stores the application data, i.e. <a href=\"#!/api/Ion.io-property-userDataPath\" rel=\"Ion.io-property-userDataPath\" class=\"docClass\">Ion.io.userDataPath</a>. If <tt>dataDirectoryName</tt>\nis not specified, it will default to the value of <tt>applicationName</tt>.\n</div>\n</div>\n\n\n\n\n<div class='entry'>\n<div class='entry-head'>applicationIconPaths [string[]]</div>\n<div class='entry-body'>\nAn array of paths to the application's default icon files. These must be an <i>.ico</i> or an <i>.icns</i> icon file for Windows and Mac OS X respectively. If any of the provided paths are not absolute, they will be relative to your configuration file.\n</div>\n</div>\n\n\n<div class='entry'>\n<div class='entry-head'>versionString [string]</div>\n<div class='entry-body'>\nString describing the version of the packaged application.\n</div>\n</div>\n\n\n<div class='entry'>\n<div class='entry-head'>webAppPath [string]</div>\n<div class='entry-body'>\nPath of the directory containing the source files for the application being packaged. This path can be full or relative. If relative it is relative to the manifest file.\n</div>\n</div>\n\n\n<div class='entry'>\n<div class='entry-head'>settings</div>\n<div class='entry-body'>\n<p>This section contains application settings.</p>\n<div class='entry'>\n<div class='entry-head'>remoteDebuggingPort [number]</div>\n<div class='entry-body'>\nPort number to use for remote debugging. If this is not set, remote debugging is disabled. \n</div>\n</div>\n<div class='entry'>\n<div class='entry-head'>mainWindow</div>\n<p>This section contains parameters related to the main application window.</p>\n<div class='entry-body'>\n<div class='entry'>\n<div class='entry-head'>autoShow [boolean: false]</div>\n<div class='entry-body'>\nIf <tt>true</tt> the application window is made visible when the application launchs, otherwise the application remains invisible until a call is made to <a href='#!/api/Ion.ui.Window-method-show'>Ion.io.mainWindow.show</a>().\n</div>\n</div>\n</div>\n</div>\n<div class='entry'>\n<div class='entry-head'>security</div>\n<div class='entry-body'>\n<p>This section contains security related parameters.</p>\n<div class='entry'>\n<div class='entry-head'>allowCrossSite [boolean: false]</div>\n<div class='entry-body'>\nIf <tt>true</tt> cross domain operations will be permitted. For example, using XMLHttpRequest calls to fetch assets from websites will be allowed.\n</div>\n</div>\n<div class='entry'>\n<div class='entry-head'>allowFileSystemAccess [boolean: false]</div>\n<div class='entry-body'>\nIf <tt>true</tt> all requests to local file system (file://) URLs will be permitted by the application.\n</div>\n</div>\n<div class='entry'>\n<div class='entry-head'>allowJavaScriptClipboardAccess [boolean: false]</div>\n<div class='entry-body'>\nIf <tt>true</tt>, JavaScript will be permitted to execute the HTML editing commands <i>Cut</i>, <i>Copy</i>, and <i>Paste</i>. E.g. <code>document.execCommand('Paste');</code>\n</div>\n</div>\n</div>\n</div>\n\n</div>\n</div>\n\n\n\n\n<div class='entry'>\n<div class='entry-head'>basicEncryption [boolean: true] <b>DEPRECATED</b></div>\n<div class='entry-body'>\nDefining basicEncryption here is deprecated and will cease to be supported in the near future.\nIf you want to use basicEncryption, please see <tt>encryption.basicEncryption</tt> below.\n</div>\n</div>\n\n\n\n\n<div class='entry'>\n<div class='entry-head'>encryption</div>\n<div class='entry-body'>\nThis section contains the values used to specify <i>no encryption</i>, <i>basic encryption</i> or <i>encryption with a RSA key pair</i>. See the <a href=\"#!/guide/application_encryption\">Application Encryption</a> guide for more information.\n<br/>\nIf both public and private keys are specified, the value of <tt>basicEncryption</tt> is ignored.\n<br/>\nOtherwise, basic encryption will be used if <tt>basicEncryption</tt> is set to <tt>true</tt>, which is the default.\n<div class='entry' id=\"quick_ref-section-50\">\n<div class='entry-head'>basicEncryption [boolean: true]</div>\n<div class='entry-body'>\nBasic encryption will be used if this value is true, and either the public key or private key or both are missing.\n</div>\n</div>\n\n<div class='entry' id=\"quick_ref-section-51\">\n<div class='entry-head'>privateKeyPath [string]</div>\n<div class='entry-body'>\nPath to the file containing the DER formatted RSA private key to use for encryption.\nThis path can be full or relative. If relative, it is relative to the manifest file.\n</div>\n</div>\n\n<div class='entry' id=\"quick_ref-section-52\">\n<div class='entry-head'>publicKeyPath [string]</div>\n<div class='entry-body'>\nPath to the file containing the DER formatted RSA public key to use for encryption.\nThis path can be full or relative. If relative, it is relative to the manifest file.\n</div>\n</div>\n\n</div>\n</div>\n\n"});