Ext.data.JsonP.release_notes({"title":"Release Notes","guide":"<h1>Release Notes</h1>\n<div class='toc'>\n<p><strong>Contents</strong></p>\n<ol>\n<li><a href='#!/guide/release_notes-section-1'>Version 1.1.1</a></li>\n<li><a href='#!/guide/release_notes-section-2'>Version 1.1</a></li>\n</ol>\n</div>\n\n<h2 id='release_notes-section-1'>Version 1.1.1</h2>\n\n<h3>General Improvements and Fixes</h3>\n\n<h4>All Platforms</h4>\n\n<ul>\n<li>Fixed the handling of URL containings references</li>\n<li>Fixed possible crash due to byte misalignment in the package header</li>\n<li>Fixed possible failure of loading URLs with multiple separators</li>\n</ul>\n\n\n<h4>Microsoft Windows</h4>\n\n<ul>\n<li>Added the support for proxy server authorization dialog</li>\n<li>Fixed incorrect path handling in ionpackage tool</li>\n<li>Fixed potential crash due to memory error when using io.watchPath</li>\n<li>Fixed possible failure in loading automatic proxy configuration script</li>\n</ul>\n\n\n<h4>Apple Mac OS X</h4>\n\n<ul>\n<li>Fixed possible failure in Ion.ion.unzip</li>\n<li>Fixed potential crash when using Cmd+Q to quit</li>\n<li>Fixed OpenGL errors on mirrored external display</li>\n<li>Fixed possible crash when using file dialogs</li>\n</ul>\n\n\n<h4>Linux</h4>\n\n<ul>\n<li>Added the support for proxy server authorization dialog</li>\n<li>Fixed missing path watcher notification of newly created files</li>\n<li>Fixed problem of closing the main window</li>\n</ul>\n\n\n<h2 id='release_notes-section-2'>Version 1.1</h2>\n\n<h3>General Improvements and Fixes</h3>\n\n<ul>\n<li>Updated to Chromium 22 code base</li>\n<li>Linux version (compatible with Ubuntu 10.04 or newer)</li>\n<li>Allow HTML editing (cut, copy, paste) on input fields</li>\n<li><a href=\"#!/api/Ion.io-method-zip\" rel=\"Ion.io-method-zip\" class=\"docClass\">Ion.io.zip</a> and <a href=\"#!/api/Ion.io-method-unzip\" rel=\"Ion.io-method-unzip\" class=\"docClass\">Ion.io.unzip</a> stream large data files to improve performance and memory consumption</li>\n<li>Improved HTML5 Audio and Video support on Windows<br/>Supported media containers are Ogg (Vorbis audio, Theora video) and WebM</li>\n<li>Activated support for Retina display on Mac OS X</li>\n<li>Ensure application window raises to the top when created</li>\n<li>Properly show multi-shortcut keyboard sequences for menu items on Mac OS X</li>\n<li>Menu items beginning with text \"About.\" and \"Preferences.\" get special treatment on Mac OS X (see <a href=\"#!/api/Ion.ui.Menu-method-addMenuItem\" rel=\"Ion.ui.Menu-method-addMenuItem\" class=\"docClass\">Ion.ui.Menu.addMenuItem</a>)</li>\n<li>New license model</li>\n</ul>\n\n\n<h3>New APIs</h3>\n\n<ul>\n<li><a href=\"#!/api/Ion.io-method-canonicalizePath\" rel=\"Ion.io-method-canonicalizePath\" class=\"docClass\">Ion.io.canonicalizePath</a> (<code>function</code>)</li>\n<li><a href=\"#!/api/Ion.io-event-pathChanged\" rel=\"Ion.io-event-pathChanged\" class=\"docClass\">Ion.io.pathChanged</a> (<code>event</code>)</li>\n<li><a href=\"#!/api/Ion.io-method-watchPath\" rel=\"Ion.io-method-watchPath\" class=\"docClass\">Ion.io.watchPath</a> / <a href=\"#!/api/Ion.io-method-unwatchPath\" rel=\"Ion.io-method-unwatchPath\" class=\"docClass\">Ion.io.unwatchPath</a> (<code>function</code>)</li>\n<li><a href=\"#!/api/Ion.io-property-watchedPaths\" rel=\"Ion.io-property-watchedPaths\" class=\"docClass\">Ion.io.watchedPaths</a> (<code>property</code>)</li>\n<li><a href=\"#!/api/Ion.io-method-zip\" rel=\"Ion.io-method-zip\" class=\"docClass\">Ion.io.zip</a> / <a href=\"#!/api/Ion.io-method-unzip\" rel=\"Ion.io-method-unzip\" class=\"docClass\">Ion.io.unzip</a> (<code>function</code>)</li>\n<li><a href=\"#!/api/Ion.net-method-hardwareAddresses\" rel=\"Ion.net-method-hardwareAddresses\" class=\"docClass\">Ion.net.hardwareAddresses</a> (<code>function</code>)</li>\n<li><a href=\"#!/api/Ion.ui.Menu-event-aboutToShow\" rel=\"Ion.ui.Menu-event-aboutToShow\" class=\"docClass\">Ion.ui.Menu.aboutToShow</a> / <a href=\"#!/api/Ion.ui.Menu-event-aboutToHide\" rel=\"Ion.ui.Menu-event-aboutToHide\" class=\"docClass\">Ion.ui.Menu.aboutToHide</a> (<code>event</code>)</li>\n<li><a href=\"#!/api/Ion.ui.Menu-method-at\" rel=\"Ion.ui.Menu-method-at\" class=\"docClass\">Ion.ui.Menu.at</a> / <a href=\"#!/api/Ion.ui.MenuBar-method-at\" rel=\"Ion.ui.MenuBar-method-at\" class=\"docClass\">Ion.ui.MenuBar.at</a> (<code>function</code>)</li>\n<li><a href=\"#!/api/Ion.ui.Menu-method-indexOf\" rel=\"Ion.ui.Menu-method-indexOf\" class=\"docClass\">Ion.ui.Menu.indexOf</a> / Ion.uiMenuBar.indexOf (<code>function</code>)</li>\n<li><a href=\"#!/api/Ion.ui.Menu-property-length\" rel=\"Ion.ui.Menu-property-length\" class=\"docClass\">Ion.ui.Menu.length</a> / <a href=\"#!/api/Ion.ui.MenuBar-property-length\" rel=\"Ion.ui.MenuBar-property-length\" class=\"docClass\">Ion.ui.MenuBar.length</a> (<code>property</code>)</li>\n<li><a href=\"#!/api/Ion.ui.Menu-method-setText\" rel=\"Ion.ui.Menu-method-setText\" class=\"docClass\">Ion.ui.Menu.setText</a> / <a href=\"#!/api/Ion.ui.MenuItem-method-setText\" rel=\"Ion.ui.MenuItem-method-setText\" class=\"docClass\">Ion.ui.MenuItem.setText</a> (<code>function</code>)</li>\n<li><a href=\"#!/api/Ion.ui.Menu-property-text\" rel=\"Ion.ui.Menu-property-text\" class=\"docClass\">Ion.ui.Menu.text</a> (<code>property</code>)</li>\n<li><a href=\"#!/api/Ion.ui.Window-method-setType\" rel=\"Ion.ui.Window-method-setType\" class=\"docClass\">Ion.ui.Window.setType</a> (<code>function</code>)</li>\n<li><a href=\"#!/api/Ion.ui.Window-property-type\" rel=\"Ion.ui.Window-property-type\" class=\"docClass\">Ion.ui.Window.type</a> (<code>property</code>)</li>\n<li><a href=\"#!/api/Ion.util-method-takeScreenshot\" rel=\"Ion.util-method-takeScreenshot\" class=\"docClass\">Ion.util.takeScreenshot</a> (<code>function</code>)</li>\n</ul>\n\n"});