Ext.data.JsonP.Ion_app({"subclasses":[],"parentMixins":[],"aliases":{},"inheritable":null,"uses":[],"alternateClassNames":[],"html_meta":{},"override":null,"extends":null,"tagname":"class","requires":[],"files":[{"href":null,"filename":"Ion.app.js"}],"superclasses":[],"singleton":true,"members":{"cfg":[],"method":[{"owner":"Ion.app","tagname":"method","name":"exit","id":"method-exit","meta":{}},{"owner":"Ion.app","tagname":"method","name":"restart","id":"method-restart","meta":{}},{"owner":"Ion.app","tagname":"method","name":"setIcon","id":"method-setIcon","meta":{}}],"property":[{"owner":"Ion.app","tagname":"property","name":"arguments","id":"property-arguments","meta":{"readonly":true}},{"owner":"Ion.app","tagname":"property","name":"fileToOpen","id":"property-fileToOpen","meta":{}},{"owner":"Ion.app","tagname":"property","name":"manifest","id":"property-manifest","meta":{"readonly":true}}],"css_var":[],"event":[{"owner":"Ion.app","tagname":"event","name":"openFile","id":"event-openFile","meta":{}}],"css_mixin":[]},"statics":{"cfg":[],"property":[],"method":[],"css_var":[],"event":[],"css_mixin":[]},"private":null,"component":false,"mixins":[],"name":"Ion.app","linenr":2,"html":"<div><div class='doc-contents'><p>Provides application-level information and utility functions including access to command-line <a href=\"#!/api/Ion.app-property-arguments\" rel=\"Ion.app-property-arguments\" class=\"docClass\">arguments</a>\nand the ability to <a href=\"#!/api/Ion.app-method-exit\" rel=\"Ion.app-method-exit\" class=\"docClass\">exit</a> the application with a specified return code.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div id='property-arguments' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.app'>Ion.app</span><br/></div><a href='#!/api/Ion.app-property-arguments' class='name expandable'>arguments</a><span> : String[]</span><strong class='readonly signature' >readonly</strong></div><div class='description'><div class='short'>Returns an array of command-line arguments that were passed to the application. ...</div><div class='long'><p>Returns an array of command-line arguments that were passed to the application.</p>\n\n<pre><code>var str = Ion.app.arguments.map(function(arg) { return '\"' + arg + '\"'; }).join(' ');\nalert('The application was passed the following argument string: ' + str);\n</code></pre>\n\n<p>Arguments beginning with \"-\" and \"--\" are considered command-line switch arguments, and are treated\nspecially. All switch arguments are placed toward the front of the arguments list while non-switch arguments\nwill follow at the tail end. The order of arguments is stable among the switch and non-switch sets.</p>\n\n<p>For example, a program called with the argument list</p>\n\n<pre><code>MyApp.exe arg1 arg2 -switch1 --switch2=value arg3 --switch3\n</code></pre>\n\n<p>will produce the following arguments array:</p>\n\n<pre><code>[\"-switch1\", \"--switch2=value\", \"--switch3\", \"arg1\", \"arg2\", \"arg3\"]\n</code></pre>\n</div></div></div><div id='property-fileToOpen' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.app'>Ion.app</span><br/></div><a href='#!/api/Ion.app-property-fileToOpen' class='name expandable'>fileToOpen</a><span> : String</span></div><div class='description'><div class='short'>Gets or sets the last file that fired the openFile event. ...</div><div class='long'><p>Gets or sets the last file that fired the <a href=\"#!/api/Ion.app-event-openFile\" rel=\"Ion.app-event-openFile\" class=\"docClass\">openFile</a> event. When the application is launched as a result\nof an associated file being double-clicked, sometimes the <a href=\"#!/api/Ion.app-event-openFile\" rel=\"Ion.app-event-openFile\" class=\"docClass\">openFile</a> event is fired prior to the web\napplication having been fully loaded and subscribed to the event.</p>\n\n<p><strong>NOTE</strong>: This property is Mac specific. It will always return an empty string on other platforms.</p>\n\n<p><em>See <a href=\"#!/api/Ion.app-event-openFile\" rel=\"Ion.app-event-openFile\" class=\"docClass\">openFile</a> for an example of how fileToOpen can be of value.</em></p>\n</div></div></div><div id='property-manifest' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.app'>Ion.app</span><br/></div><a href='#!/api/Ion.app-property-manifest' class='name expandable'>manifest</a><span> : Object</span><strong class='readonly signature' >readonly</strong></div><div class='description'><div class='short'>Returns an object which represents the contents of the config file used to package this application. ...</div><div class='long'><p>Returns an object which represents the contents of the config file used to package this application.</p>\n\n<pre><code>alert('The application name is ' + Ion.app.manifest.applicationName);\n</code></pre>\n</div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-exit' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.app'>Ion.app</span><br/></div><a href='#!/api/Ion.app-method-exit' class='name expandable'>exit</a>( <span class='pre'>[Number returnCode]</span> )</div><div class='description'><div class='short'>Exit the application with the optionally specified return code. ...</div><div class='long'><p>Exit the application with the optionally specified return code.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>returnCode</span> : Number (optional)<div class='sub-desc'><p>The status code to be returned when the application exits.</p>\n<p>Defaults to: <code>0</code></p></div></li></ul></div></div></div><div id='method-restart' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.app'>Ion.app</span><br/></div><a href='#!/api/Ion.app-method-restart' class='name expandable'>restart</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Restart the application. ...</div><div class='long'><p>Restart the application.</p>\n\n<p>Calling this method causes the application to restart with it's original argument list.</p>\n\n<p>The calling instance of the application is terminated.</p>\n</div></div></div><div id='method-setIcon' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.app'>Ion.app</span><br/></div><a href='#!/api/Ion.app-method-setIcon' class='name expandable'>setIcon</a>( <span class='pre'>[String iconPath]</span> )</div><div class='description'><div class='short'>Sets the application's Dock tile icon. ...</div><div class='long'><p>Sets the application's Dock tile icon.</p>\n\n<p><strong>NOTE</strong>: This method is Mac specific at this time.</p>\n\n<pre><code>// Set the application's Dock icon.\n<a href=\"#!/api/Ion.app-method-setIcon\" rel=\"Ion.app-method-setIcon\" class=\"docClass\">Ion.app.setIcon</a>('myicon.png');\n\n// Reset to the default application icon.\n<a href=\"#!/api/Ion.app-method-setIcon\" rel=\"Ion.app-method-setIcon\" class=\"docClass\">Ion.app.setIcon</a>();\n</code></pre>\n\n<p>Valid image types include BMP, GIF, ICO, JPEG, PNG, and ICNS. The image will be scaled\nto fit automatically.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>iconPath</span> : String (optional)<div class='sub-desc'><p>The path to the icon file. If this argument is omitted or the icon file is not able to be loaded,\nthe application's default icon will be set.</p>\n</div></li></ul></div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-event'>Events</h3><div class='subsection'><div id='event-openFile' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.app'>Ion.app</span><br/></div><a href='#!/api/Ion.app-event-openFile' class='name expandable'>openFile</a>( <span class='pre'>String filePath</span> )</div><div class='description'><div class='short'>Fired when an associated application file is double-clicked, or when any file is dragged onto the app icon in\nthe Dock. ...</div><div class='long'><p>Fired when an associated application file is double-clicked, or when any file is dragged onto the app icon in\nthe Dock.</p>\n\n<p><strong>NOTE</strong>: This event is Mac specific. It will never fire on other platforms.</p>\n\n<pre><code>function tryOpenFile(filePath) {\n    // If the file is a text file, we can handle it.\n    if (/\\.txt/i.test(filePath)) {\n        if(<a href=\"#!/api/Ion.io\" rel=\"Ion.io\" class=\"docClass\">Ion.io</a>.<a href=\"#!/api/Ion.io-method-pathExists\" rel=\"Ion.io-method-pathExists\" class=\"docClass\">pathExists</a>(filePath)) {\n            var fileHandle = <a href=\"#!/api/Ion.io\" rel=\"Ion.io\" class=\"docClass\">Ion.io</a>.<a href=\"#!/api/Ion.io-method-readFile\" rel=\"Ion.io-method-readFile\" class=\"docClass\">readFile</a>(filePath);\n            // do something interesting\n        } else {\n           alert('FILE NOT FOUND:\\n\\n' + filePath);\n        }\n    }\n}\n\n// If the user double-clicked a file associated to this app that caused the app to launch,\n// we want to see if we have a file \"queued\" to be opened.\nif (<a href=\"#!/api/Ion.app-property-fileToOpen\" rel=\"Ion.app-property-fileToOpen\" class=\"docClass\">Ion.app.fileToOpen</a>) {\n    tryOpenFile(<a href=\"#!/api/Ion.app-property-fileToOpen\" rel=\"Ion.app-property-fileToOpen\" class=\"docClass\">Ion.app.fileToOpen</a>);\n}\n\n// Subscribe to the openFile event to be notified when a user double-clicks an associated app file,\n// or when a file is dropped onto the app icon in the Dock.\nfunction onOpenFile(filePath) {\n    tryOpenFile(filePath);\n}\n<a href=\"#!/api/Ion.app\" rel=\"Ion.app\" class=\"docClass\">Ion.app</a>.<a href=\"#!/api/Ion.app-event-openFile\" rel=\"Ion.app-event-openFile\" class=\"docClass\">openFile</a>.connect(onOpenFile);\n\nfunction shutdown() {\n    // No longer need to listen to openFile...\n    <a href=\"#!/api/Ion.app\" rel=\"Ion.app\" class=\"docClass\">Ion.app</a>.<a href=\"#!/api/Ion.app-event-openFile\" rel=\"Ion.app-event-openFile\" class=\"docClass\">openFile</a>.disconnect(onOpenFile);\n}\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>filePath</span> : String<div class='sub-desc'><p>The absolute path of the file that wants to open in the application.</p>\n</div></li></ul></div></div></div></div></div></div></div>","inheritdoc":null,"enum":null,"id":"class-Ion.app","mixedInto":[],"meta":{}});