Ext.data.JsonP.Ion_crypto({"subclasses":[],"parentMixins":[],"aliases":{},"inheritable":null,"uses":[],"alternateClassNames":[],"html_meta":{},"override":null,"extends":null,"tagname":"class","requires":[],"files":[{"href":null,"filename":"Ion.crypto.js"}],"superclasses":[],"singleton":true,"members":{"cfg":[],"method":[{"owner":"Ion.crypto","tagname":"method","name":"calculateHash","id":"method-calculateHash","meta":{}},{"owner":"Ion.crypto","tagname":"method","name":"md5Hash","id":"method-md5Hash","meta":{}},{"owner":"Ion.crypto","tagname":"method","name":"sha1Hash","id":"method-sha1Hash","meta":{}}],"property":[],"css_var":[],"event":[],"css_mixin":[]},"statics":{"cfg":[],"property":[],"method":[],"css_var":[],"event":[],"css_mixin":[]},"private":null,"component":false,"mixins":[],"name":"Ion.crypto","linenr":1,"html":"<div><div class='doc-contents'><p>Contains methods that provide crypto related functionality.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-calculateHash' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.crypto'>Ion.crypto</span><br/></div><a href='#!/api/Ion.crypto-method-calculateHash' class='name expandable'>calculateHash</a>( <span class='pre'>String data, [String format], [String algorithm]</span> ) : String</div><div class='description'><div class='short'>Generate a hash value, formatted either as hex or base64, using the specified algorithm. ...</div><div class='long'><p>Generate a hash value, formatted either as hex or base64, using the specified algorithm.</p>\n\n<pre><code>// This gives 'sQqNsWTgdUEFt6mb5y4/5Q=='\nvar result = <a href=\"#!/api/Ion.crypto-method-calculateHash\" rel=\"Ion.crypto-method-calculateHash\" class=\"docClass\">Ion.crypto.calculateHash</a>('Hello World', 'base64', 'md5');\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>data</span> : String<div class='sub-desc'>\n</div></li><li><span class='pre'>format</span> : String (optional)<div class='sub-desc'><p>The format of the hash output. Valid values are <code>hex</code> and <code>base64</code>.</p>\n<p>Defaults to: <code>&quot;hex&quot;</code></p></div></li><li><span class='pre'>algorithm</span> : String (optional)<div class='sub-desc'><p>The hashing algorithm to use. Must be either <code>md5</code> or <code>sha1</code>.</p>\n<p>Defaults to: <code>&quot;md5&quot;</code></p></div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>Returns the hash.</p>\n</div></li></ul></div></div></div><div id='method-md5Hash' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.crypto'>Ion.crypto</span><br/></div><a href='#!/api/Ion.crypto-method-md5Hash' class='name expandable'>md5Hash</a>( <span class='pre'>String data, [String format]</span> ) : String</div><div class='description'><div class='short'>Generate a hash value, formatted either as hex or base64, using the MD5 Message-Digest Algorithm. ...</div><div class='long'><p>Generate a hash value, formatted either as hex or base64, using the MD5 Message-Digest Algorithm.</p>\n\n<pre><code>// This gives 'd1ada774a653f6602458712a06288fa4'\nvar result = <a href=\"#!/api/Ion.crypto-method-md5Hash\" rel=\"Ion.crypto-method-md5Hash\" class=\"docClass\">Ion.crypto.md5Hash</a>('Sencha', 'hex');\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>data</span> : String<div class='sub-desc'>\n</div></li><li><span class='pre'>format</span> : String (optional)<div class='sub-desc'><p>The format of the hash output. Valid values are <code>hex</code> and <code>base64</code>.</p>\n<p>Defaults to: <code>&quot;hex&quot;</code></p></div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>Returns the hash.</p>\n</div></li></ul></div></div></div><div id='method-sha1Hash' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.crypto'>Ion.crypto</span><br/></div><a href='#!/api/Ion.crypto-method-sha1Hash' class='name expandable'>sha1Hash</a>( <span class='pre'>String data, [String format]</span> ) : String</div><div class='description'><div class='short'>Generate a hash value, formatted either as hex or base64, using SHA-1 hash function. ...</div><div class='long'><p>Generate a hash value, formatted either as hex or base64, using SHA-1 hash function.</p>\n\n<pre><code>// This gives '576ece08a6d4f1e4bd1cf06576b43800daca41ff'\nvar result = <a href=\"#!/api/Ion.crypto-method-sha1Hash\" rel=\"Ion.crypto-method-sha1Hash\" class=\"docClass\">Ion.crypto.sha1Hash</a>('Sencha', 'hex');\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>data</span> : String<div class='sub-desc'>\n</div></li><li><span class='pre'>format</span> : String (optional)<div class='sub-desc'><p>The format of the hash output. Valid values are <code>hex</code> and <code>base64</code>.</p>\n<p>Defaults to: <code>&quot;hex&quot;</code></p></div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>Returns the hash.</p>\n</div></li></ul></div></div></div></div></div></div></div>","inheritdoc":null,"enum":null,"id":"class-Ion.crypto","mixedInto":[],"meta":{}});