Ext.data.JsonP.Ion_io({"subclasses":[],"parentMixins":[],"aliases":{},"inheritable":null,"uses":[],"alternateClassNames":[],"html_meta":{},"override":null,"extends":null,"tagname":"class","requires":[],"files":[{"href":null,"filename":"Ion.io.js"}],"superclasses":[],"singleton":true,"members":{"cfg":[],"method":[{"owner":"Ion.io","tagname":"method","name":"browseDirectories","id":"method-browseDirectories","meta":{}},{"owner":"Ion.io","tagname":"method","name":"browseFiles","id":"method-browseFiles","meta":{}},{"owner":"Ion.io","tagname":"method","name":"canonicalizePath","id":"method-canonicalizePath","meta":{}},{"owner":"Ion.io","tagname":"method","name":"copyPath","id":"method-copyPath","meta":{}},{"owner":"Ion.io","tagname":"method","name":"deletePath","id":"method-deletePath","meta":{}},{"owner":"Ion.io","tagname":"method","name":"listDirectory","id":"method-listDirectory","meta":{}},{"owner":"Ion.io","tagname":"method","name":"pathExists","id":"method-pathExists","meta":{}},{"owner":"Ion.io","tagname":"method","name":"readFile","id":"method-readFile","meta":{}},{"owner":"Ion.io","tagname":"method","name":"unwatchPath","id":"method-unwatchPath","meta":{}},{"owner":"Ion.io","tagname":"method","name":"unzip","id":"method-unzip","meta":{}},{"owner":"Ion.io","tagname":"method","name":"watchPath","id":"method-watchPath","meta":{}},{"owner":"Ion.io","tagname":"method","name":"writeFile","id":"method-writeFile","meta":{}},{"owner":"Ion.io","tagname":"method","name":"zip","id":"method-zip","meta":{}}],"property":[{"owner":"Ion.io","tagname":"property","name":"tempPath","id":"property-tempPath","meta":{"markdown":true,"readonly":true}},{"owner":"Ion.io","tagname":"property","name":"userDataPath","id":"property-userDataPath","meta":{"readonly":true}},{"owner":"Ion.io","tagname":"property","name":"userDesktopPath","id":"property-userDesktopPath","meta":{"readonly":true}},{"owner":"Ion.io","tagname":"property","name":"userDocsPath","id":"property-userDocsPath","meta":{"readonly":true}},{"owner":"Ion.io","tagname":"property","name":"userHomePath","id":"property-userHomePath","meta":{"readonly":true}},{"owner":"Ion.io","tagname":"property","name":"watchedPaths","id":"property-watchedPaths","meta":{"readonly":true}}],"css_var":[],"event":[{"owner":"Ion.io","tagname":"event","name":"pathChanged","id":"event-pathChanged","meta":{}}],"css_mixin":[]},"statics":{"cfg":[],"property":[],"method":[],"css_var":[],"event":[],"css_mixin":[]},"private":null,"component":false,"mixins":[],"name":"Ion.io","linenr":1,"html":"<div><div class='doc-contents'><p>Contains properties and methods that provide I/O functionality.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div id='property-tempPath' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-property-tempPath' class='name expandable'>tempPath</a><span> : String</span><strong class='readonly signature' >readonly</strong></div><div class='description'><div class='short'>Get the path to a temporary file area on the system for the active user. ...</div><div class='long'><p>Get the path to a temporary file area on the system for the active user.</p>\n\n<p><strong>E.g.</strong>:</p>\n\n<ul>\n<li>Mac OS X/Linux: <code>/tmp/</code></li>\n<li>Windows: <code>C:/Users/jarred/AppData/Local/Temp/</code></li>\n</ul>\n\n\n<!-- fool the duck -->\n\n\n<pre><code>// Read our temp file that is storing cache\nvar result = <a href=\"#!/api/Ion.io-method-readFile\" rel=\"Ion.io-method-readFile\" class=\"docClass\">Ion.io.readFile</a>(<a href=\"#!/api/Ion.io-property-tempPath\" rel=\"Ion.io-property-tempPath\" class=\"docClass\">Ion.io.tempPath</a> + 'MyApp.cache');\nif (result.success) {\n    // Cache was present and read successfully, so let's load it up!\n    MyApp.loadCache(result.data);\n}\n</code></pre>\n</div></div></div><div id='property-userDataPath' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-property-userDataPath' class='name expandable'>userDataPath</a><span> : String</span><strong class='readonly signature' >readonly</strong></div><div class='description'><div class='short'>Get the path to a data file area on the system for the active user. ...</div><div class='long'><p>Get the path to a data file area on the system for the active user.</p>\n\n<p><strong>NOTE</strong>: In the near future, custom Organization and Application names will be configurable. The Organization\nand Application names currently default to <code>\"Sencha\"</code> and <code>\"Sencha Ion\"</code> respectively.</p>\n\n<p><strong>E.g.</strong>:</p>\n\n<ul>\n<li>Mac OS X: <code>/Users/jarred/Library/Application Support/OrgName/AppName/</code></li>\n<li>Windows: <code>C:/Users/jarred/AppData/Local/OrgName/AppName/</code></li>\n<li>Linux: <code>/home/jarred/.local/share/data/OrgName/AppName/</code></li>\n</ul>\n\n</div></div></div><div id='property-userDesktopPath' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-property-userDesktopPath' class='name expandable'>userDesktopPath</a><span> : String</span><strong class='readonly signature' >readonly</strong></div><div class='description'><div class='short'>Get the path to the desktop area on the system for the active user. ...</div><div class='long'><p>Get the path to the desktop area on the system for the active user.</p>\n\n<p><strong>E.g.</strong>:</p>\n\n<ul>\n<li>Mac OS X: <code>/Users/jarred/Desktop/</code></li>\n<li>Windows: <code>C:/Users/jarred/Desktop/</code></li>\n<li>Linux: <code>/home/jarred/Desktop/</code></li>\n</ul>\n\n</div></div></div><div id='property-userDocsPath' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-property-userDocsPath' class='name expandable'>userDocsPath</a><span> : String</span><strong class='readonly signature' >readonly</strong></div><div class='description'><div class='short'>Gets the path to the documents or \"My Documents\" area on the system for the active user. ...</div><div class='long'><p>Gets the path to the documents or \"My Documents\" area on the system for the active user.</p>\n\n<p><strong>E.g.</strong>:</p>\n\n<ul>\n<li>Mac OS X: <code>/Users/jarred/Documents/</code></li>\n<li>Windows: <code>C:/Users/jarred/Documents/</code></li>\n<li>Linux: <code>/home/jarred/Documents/</code></li>\n</ul>\n\n</div></div></div><div id='property-userHomePath' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-property-userHomePath' class='name expandable'>userHomePath</a><span> : String</span><strong class='readonly signature' >readonly</strong></div><div class='description'><div class='short'>Gets the path to the home directory on the system for the active user. ...</div><div class='long'><p>Gets the path to the home directory on the system for the active user.</p>\n\n<p><strong>E.g.</strong>:</p>\n\n<ul>\n<li>Mac OS X: <code>/Users/jarred/</code></li>\n<li>Windows: <code>C:/Users/jarred/</code></li>\n<li>Linux: <code>/home/jarred/</code></li>\n</ul>\n\n</div></div></div><div id='property-watchedPaths' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-property-watchedPaths' class='name not-expandable'>watchedPaths</a><span> : String[]</span><strong class='readonly signature' >readonly</strong></div><div class='description'><div class='short'><p>An array of directory paths currently being watched.</p>\n</div><div class='long'><p>An array of directory paths currently being watched.</p>\n</div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-browseDirectories' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-method-browseDirectories' class='name expandable'>browseDirectories</a>( <span class='pre'>[Object options]</span> ) : Object</div><div class='description'><div class='short'>Opens native directory chooser dialog. ...</div><div class='long'><p>Opens native directory chooser dialog.</p>\n\n<pre><code>// Let the user choose where to save our text file.\nvar result = <a href=\"#!/api/Ion.io-method-browseDirectories\" rel=\"Ion.io-method-browseDirectories\" class=\"docClass\">Ion.io.browseDirectories</a>({\n    path: <a href=\"#!/api/Ion.io-property-userHomePath\" rel=\"Ion.io-property-userHomePath\" class=\"docClass\">Ion.io.userHomePath</a>\n});\n\nif (result.success) {\n    <a href=\"#!/api/Ion.io-method-writeFile\" rel=\"Ion.io-method-writeFile\" class=\"docClass\">Ion.io.writeFile</a>(result.value + '/myfile.txt', data);\n}\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>options</span> : Object (optional)<div class='sub-desc'><p>Object containing the following options:</p>\n<ul><li><span class='pre'>caption</span> : String (optional)<div class='sub-desc'><p>The title of the dialog window.</p>\n<p>Defaults to: <code>&quot;Choose Directory&quot;</code></p></div></li><li><span class='pre'>path</span> : String (optional)<div class='sub-desc'><p>The initial directory that the user will begin navigating. <code>path</code> will be canonicalized (see <code><a href=\"#!/api/Ion.io-method-canonicalizePath\" rel=\"Ion.io-method-canonicalizePath\" class=\"docClass\">Ion.io.canonicalizePath</a>()</code>)</p>\n\n<p><strong>NOTE</strong>: This option has no effect on Windows at this time.</p>\n</div></li></ul></div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>Returns an object with the following structure:</p>\n\n<ul>\n<li><code>success</code> : Boolean<br/>\n<code>true</code> if the user selected a directory. <code>false</code> if the user closed/cancelled the dialog.</li>\n<li><code>value</code> : String<br/>\nThe full path to the selected directory.</li>\n</ul>\n\n</div></li></ul></div></div></div><div id='method-browseFiles' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-method-browseFiles' class='name expandable'>browseFiles</a>( <span class='pre'>[Object options]</span> ) : Object</div><div class='description'><div class='short'>Opens native file chooser dialog. ...</div><div class='long'><p>Opens native file chooser dialog.</p>\n\n<pre><code>// Let the user choose the JSON file to open and read.\nvar result = <a href=\"#!/api/Ion.io-method-browseFiles\" rel=\"Ion.io-method-browseFiles\" class=\"docClass\">Ion.io.browseFiles</a>({\n    path: <a href=\"#!/api/Ion.io-property-userHomePath\" rel=\"Ion.io-property-userHomePath\" class=\"docClass\">Ion.io.userHomePath</a>,\n    type: 'open',\n    filters: [{\n        name: 'JSON Files',\n        pattern: '*.json'\n    }]\n});\n\nif (result.success) {\n    var read = <a href=\"#!/api/Ion.io-method-readFile\" rel=\"Ion.io-method-readFile\" class=\"docClass\">Ion.io.readFile</a>(result.value);\n    if (read.success) {\n        var obj = JSON.parse(read.data);\n        // Do something with obj...\n    }\n}\n</code></pre>\n\n<h3>Filters</h3>\n\n<p>On some platforms the file browser dialog supports a list of filters that\nthe end user can use to filter which files are shown in the dialog. Each\nfilter in the list consists of two parts:</p>\n\n<ul>\n<li><code>name</code>: Descriptive text that the end user will see.</li>\n<li><code>pattern</code>: The pattern (String) or patterns (String[]) this filter matches.</li>\n</ul>\n\n\n<p>Filters can be defined as Objects with the fields <code>name</code> and <code>pattern</code> or as an\nArray of two parts, the <code>name</code> followed by the <code>pattern</code> String or String[].</p>\n\n<p>For example:</p>\n\n<pre><code>filters: [\n    ['Image Files', ['*.jpg', '*.jpeg', '*.png']],\n    ['All Files', '*.*']\n]\n</code></pre>\n\n<p>and</p>\n\n<pre><code>filters: [{\n    name: 'Image Files',\n    pattern: ['*.jpg', '*.jpeg', '*.png']\n}, {\n    name: 'All Files',\n    pattern: '*.*'\n}]\n</code></pre>\n\n<p>both define the same list of filters.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>options</span> : Object (optional)<div class='sub-desc'><p>Object containing the following options:</p>\n<ul><li><span class='pre'>caption</span> : String (optional)<div class='sub-desc'><p>The title of the dialog window.</p>\n\n<p>Defaults to: <code>\"Open File\"</code> or <code>\"Save File\"</code> based on <code>type</code></p>\n</div></li><li><span class='pre'>defaultValue</span> : String (optional)<div class='sub-desc'><p>The name of the file that will attempt to be pre-populated as the selected value.</p>\n</div></li><li><span class='pre'>filters</span> : Array[]/Object[] (optional)<div class='sub-desc'><p>Defines the list of filters to provide in the file browser dialog. See above for details.</p>\n\n<p><strong>Note</strong>: Mac OS X will enable selections which match <strong>at least one</strong> of the provided filter patterns. <em>This is temporary</em>.</p>\n<p>Defaults to: <code>[[&quot;All Files&quot;, &quot;*.*&quot;]]</code></p></div></li><li><span class='pre'>path</span> : String (optional)<div class='sub-desc'><p>The initial directory that the user will begin navigating. <code>path</code> will be canonicalized (see <code><a href=\"#!/api/Ion.io-method-canonicalizePath\" rel=\"Ion.io-method-canonicalizePath\" class=\"docClass\">Ion.io.canonicalizePath</a>()</code>)</p>\n</div></li><li><span class='pre'>type</span> : String (optional)<div class='sub-desc'><p>Whether this is a save dialog (allows a path/value that is non-existent) or an open dialog\n(the path/value must exist on the file system).</p>\n<p>Defaults to: <code>&quot;save&quot;</code></p></div></li></ul></div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>Returns an object with the following structure:</p>\n\n<ul>\n<li><code>success</code> : Boolean<br/>\n<code>true</code> if the user selected a file. <code>false</code> if the user closed/cancelled the dialog.</li>\n<li><code>value</code> : String\nThe full path to the selected file.</li>\n</ul>\n\n</div></li></ul></div></div></div><div id='method-canonicalizePath' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-method-canonicalizePath' class='name expandable'>canonicalizePath</a>( <span class='pre'>String The</span> ) : String</div><div class='description'><div class='short'>Canonicalizes a file system path if necessary. ...</div><div class='long'><p>Canonicalizes a file system path if necessary.</p>\n\n<ul>\n<li>\"~/\" prefix expands to <code><a href=\"#!/api/Ion.io-property-userHomePath\" rel=\"Ion.io-property-userHomePath\" class=\"docClass\">Ion.io.userHomePath</a>()</code></li>\n<li>\"-/\" prefix expands to <code><a href=\"#!/api/Ion.io-property-userDataPath\" rel=\"Ion.io-property-userDataPath\" class=\"docClass\">Ion.io.userDataPath</a>()</code></li>\n</ul>\n\n\n<p>If no convertable prefix is found, the <code>path</code> passed in as a parameter is returned unmodified.  * All <code><a href=\"#!/api/Ion.io\" rel=\"Ion.io\" class=\"docClass\">Ion.io</a></code> member functions that take a path as a parameter, call this function internally,\nso you can pass in paths using the above prefixes.</p>\n\n<pre><code>// Open `config.json` in user's home directory\nvar config = <a href=\"#!/api/Ion.io-method-readFile\" rel=\"Ion.io-method-readFile\" class=\"docClass\">Ion.io.readFile</a>(<a href=\"#!/api/Ion.io-method-canonicalizePath\" rel=\"Ion.io-method-canonicalizePath\" class=\"docClass\">Ion.io.canonicalizePath</a>('~/config.json'));\n\n// Can also open the file like this, because `<a href=\"#!/api/Ion.io-method-readFile\" rel=\"Ion.io-method-readFile\" class=\"docClass\">Ion.io.readFile</a>()` calls\n// `canonicalizePath()` for you:\nvar config = <a href=\"#!/api/Ion.io-method-browseFiles\" rel=\"Ion.io-method-browseFiles\" class=\"docClass\">Ion.io.browseFiles</a>({path: '~/config.json'});\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>The</span> : String<div class='sub-desc'><p>path to be converted.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>The canonicalized path.</p>\n</div></li></ul></div></div></div><div id='method-copyPath' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-method-copyPath' class='name expandable'>copyPath</a>( <span class='pre'>String fromPath, String toPath</span> ) : Boolean</div><div class='description'><div class='short'>If fromPath is a Directory: copies deeply all files and directories from fromPath to toPath. ...</div><div class='long'><p>If <code>fromPath</code> is a Directory: copies deeply all files and directories from <code>fromPath</code> to <code>toPath</code>.</p>\n\n<p>If <code>fromPath</code> is a File: copies the file to <code>toPath</code>.</p>\n\n<p>If the destination directory does not already exist, an attempt to create it will be made.</p>\n\n<pre><code>// Copy dir1 and its contents to dir2, resulting in /path/to/dir2/dir1/&lt;dir1_contents&gt;\nif (!<a href=\"#!/api/Ion.io-method-copyPath\" rel=\"Ion.io-method-copyPath\" class=\"docClass\">Ion.io.copyPath</a>('/path/to/dir1', '/path/to/dir2')) {\n    alert('Failed to copy directory!');\n}\n\n// Copy dir1 contents to dir2, resulting in /path/to/dir2/&lt;dir1_contents&gt;\nif (!<a href=\"#!/api/Ion.io-method-copyPath\" rel=\"Ion.io-method-copyPath\" class=\"docClass\">Ion.io.copyPath</a>('/path/to/dir1/.', '/path/to/dir2')) {\n    alert('Failed to copy directory!');\n}\n\n// Copy file to destination path, resulting in /path/to/dir/new_file\nif (!<a href=\"#!/api/Ion.io-method-copyPath\" rel=\"Ion.io-method-copyPath\" class=\"docClass\">Ion.io.copyPath</a>('/path/to/file', '/path/to/dir/new_file')) {\n    alert('Failed to copy file!');\n}\n\n// Copy file to dir, resulting in /path/to/dir/file\nif (!<a href=\"#!/api/Ion.io-method-copyPath\" rel=\"Ion.io-method-copyPath\" class=\"docClass\">Ion.io.copyPath</a>('/path/to/file', '/path/to/dir/.')) {\n    alert('Failed to copy file!');\n}\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>fromPath</span> : String<div class='sub-desc'><p>The file or directory to copy to <code>toPath</code>.  <code>toPath</code> will be canonicalized (see <code><a href=\"#!/api/Ion.io-method-canonicalizePath\" rel=\"Ion.io-method-canonicalizePath\" class=\"docClass\">Ion.io.canonicalizePath</a>()</code>)</p>\n</div></li><li><span class='pre'>toPath</span> : String<div class='sub-desc'><p>The destination path to where <code>fromPath</code> will be copied. <code>fromPath</code> will be canonicalized (see <code><a href=\"#!/api/Ion.io-method-canonicalizePath\" rel=\"Ion.io-method-canonicalizePath\" class=\"docClass\">Ion.io.canonicalizePath</a>()</code>)</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>Returns whether or not the copy operation finished completely and successfully.</p>\n</div></li></ul></div></div></div><div id='method-deletePath' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-method-deletePath' class='name expandable'>deletePath</a>( <span class='pre'>String path</span> ) : Boolean</div><div class='description'><div class='short'>If path is a Directory: deeply deletes all files and folders from path and then deletes path. ...</div><div class='long'><p>If <code>path</code> is a Directory: deeply deletes all files and folders from <code>path</code> and then deletes <code>path</code>.</p>\n\n<p>If <code>path</code> is a File: deletes <code>path</code>.</p>\n\n<pre><code>// Delete dir completely\nif (!<a href=\"#!/api/Ion.io-method-deletePath\" rel=\"Ion.io-method-deletePath\" class=\"docClass\">Ion.io.deletePath</a>('/path/to/dir')) {\n    alert('Failed to delete directory!');\n}\n\n// Delete file\nif (!<a href=\"#!/api/Ion.io-method-deletePath\" rel=\"Ion.io-method-deletePath\" class=\"docClass\">Ion.io.deletePath</a>('/path/to/file')) {\n    alert('Failed to delete file!');\n}\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>path</span> : String<div class='sub-desc'><p>The file or directory to delete. <code>path</code> will be canonicalized (see <code><a href=\"#!/api/Ion.io-method-canonicalizePath\" rel=\"Ion.io-method-canonicalizePath\" class=\"docClass\">Ion.io.canonicalizePath</a>()</code>)</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>Returns whether or not the delete operation finished completely and successfully.</p>\n</div></li></ul></div></div></div><div id='method-listDirectory' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-method-listDirectory' class='name expandable'>listDirectory</a>( <span class='pre'>String path, [Object options]</span> )</div><div class='description'><div class='short'>Lists the names of all files and directories under the specified path. ...</div><div class='long'><p>Lists the names of all files and directories under the specified <code>path</code>.\nThis operation is not deep and will only list immediate children of <code>path</code>.</p>\n\n<pre><code> var items = <a href=\"#!/api/Ion.io-method-listDirectory\" rel=\"Ion.io-method-listDirectory\" class=\"docClass\">Ion.io.listDirectory</a>(<a href=\"#!/api/Ion.io-property-userDataPath\" rel=\"Ion.io-property-userDataPath\" class=\"docClass\">Ion.io.userDataPath</a> + 'records', { directories: false });\n for (var i = 0; i &lt; items.length; i++) {\n     MyApp.loadRecordFromFile(<a href=\"#!/api/Ion.io-property-userDataPath\" rel=\"Ion.io-property-userDataPath\" class=\"docClass\">Ion.io.userDataPath</a> + 'records/' + items[i]);\n }\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>path</span> : String<div class='sub-desc'><p>The path of the directory to list. <code>path</code> will be canonicalized (see <code><a href=\"#!/api/Ion.io-method-canonicalizePath\" rel=\"Ion.io-method-canonicalizePath\" class=\"docClass\">Ion.io.canonicalizePath</a>()</code>)</p>\n</div></li><li><span class='pre'>options</span> : Object (optional)<div class='sub-desc'>\n<ul><li><span class='pre'>directories</span> : Boolean (optional)<div class='sub-desc'><p>Whether or not to include directories in the result set.</p>\n<p>Defaults to: <code>true</code></p></div></li><li><span class='pre'>files</span> : Boolean (optional)<div class='sub-desc'><p>Whether or not to include files in the result set.</p>\n<p>Defaults to: <code>true</code></p></div></li></ul></div></li></ul></div></div></div><div id='method-pathExists' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-method-pathExists' class='name expandable'>pathExists</a>( <span class='pre'>String path</span> ) : Boolean</div><div class='description'><div class='short'>Checks whether or not the specified path (file or directory) exists. ...</div><div class='long'><p>Checks whether or not the specified <code>path</code> (file or directory) exists.</p>\n\n<pre><code>if (<a href=\"#!/api/Ion.io-method-pathExists\" rel=\"Ion.io-method-pathExists\" class=\"docClass\">Ion.io.pathExists</a>('/path/to/file')) {\n    <a href=\"#!/api/Ion.io-method-deletePath\" rel=\"Ion.io-method-deletePath\" class=\"docClass\">Ion.io.deletePath</a>('/path/to/file');\n}\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>path</span> : String<div class='sub-desc'><p><code>path</code> will be canonicalized (see <code><a href=\"#!/api/Ion.io-method-canonicalizePath\" rel=\"Ion.io-method-canonicalizePath\" class=\"docClass\">Ion.io.canonicalizePath</a>()</code>)</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>Returns whether or not <code>path</code> exists.</p>\n</div></li></ul></div></div></div><div id='method-readFile' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-method-readFile' class='name expandable'>readFile</a>( <span class='pre'>String filePath, [Object options]</span> ) : Object</div><div class='description'><div class='short'>Reads the entire contents of filePath. ...</div><div class='long'><p>Reads the entire contents of <code>filePath</code>. If the mode is <code>text</code>, the contents are\nread as UTF-8 encoded text. If the mode is <code>binary</code> then the contents are read as binary data.</p>\n\n<p><strong>NOTE:</strong> Files in UTF-16BE and UTF-16LE formats will be automatically detected and decoded accordingly.</p>\n\n<pre><code>// Let the user choose the JSON file to open and read.\nvar result = <a href=\"#!/api/Ion.io-method-browseFiles\" rel=\"Ion.io-method-browseFiles\" class=\"docClass\">Ion.io.browseFiles</a>({\n    path: <a href=\"#!/api/Ion.io-property-userHomePath\" rel=\"Ion.io-property-userHomePath\" class=\"docClass\">Ion.io.userHomePath</a>,\n    type: 'open',\n    filters: [{\n        name: 'JSON Files',\n        pattern: '*.json'\n    }]\n});\n\nif (result.success) {\n    var read = <a href=\"#!/api/Ion.io-method-readFile\" rel=\"Ion.io-method-readFile\" class=\"docClass\">Ion.io.readFile</a>(result.value);\n    if (read.success) {\n        var obj = JSON.parse(read.data);\n        // Do something with obj...\n    }\n}\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>filePath</span> : String<div class='sub-desc'><p>The path of the file to read.</p>\n</div></li><li><span class='pre'>options</span> : Object (optional)<div class='sub-desc'>\n<ul><li><span class='pre'>mode</span> : String (optional)<div class='sub-desc'><p>The mode in which to read the file, either <code>text</code> or <code>binary</code>.</p>\n<p>Defaults to: <code>&quot;text&quot;</code></p></div></li></ul></div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>Returns an object with the following structure:</p>\n\n<ul>\n<li><code>success</code> : Boolean</li>\n<li><code>data</code> : String/Number[]<br/>\nEither a String when mode is <code>text</code>, or a Number[] (one Number per byte) when mode is <code>binary</code>.</li>\n</ul>\n\n</div></li></ul></div></div></div><div id='method-unwatchPath' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-method-unwatchPath' class='name expandable'>unwatchPath</a>( <span class='pre'>String path</span> ) : Boolean</div><div class='description'><div class='short'>Remove a path from the list of watched directories (see Ion.io.watchedPaths and Ion.io.pathChanged). ...</div><div class='long'><p>Remove a path from the list of watched directories (see <code><a href=\"#!/api/Ion.io-property-watchedPaths\" rel=\"Ion.io-property-watchedPaths\" class=\"docClass\">Ion.io.watchedPaths</a></code> and <code><a href=\"#!/api/Ion.io-event-pathChanged\" rel=\"Ion.io-event-pathChanged\" class=\"docClass\">Ion.io.pathChanged</a></code>).</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>path</span> : String<div class='sub-desc'><p>The path of the directory to stop watching.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p><code>true</code> if the path was successfully unwatched, <code>false</code> if not.</p>\n</div></li></ul></div></div></div><div id='method-unzip' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-method-unzip' class='name expandable'>unzip</a>( <span class='pre'>String filePath, String path</span> ) : Boolean</div><div class='description'><div class='short'>Unzip a file. ...</div><div class='long'><p>Unzip a file.</p>\n\n<pre><code>// Unzip the contents of myfile.zip into myfolder\nvar success = <a href=\"#!/api/Ion.io-method-unzip\" rel=\"Ion.io-method-unzip\" class=\"docClass\">Ion.io.unzip</a>('myfile.zip', '~/myfolder');\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>filePath</span> : String<div class='sub-desc'><p>The path to the zipped file. <code>filePath</code> will be canonicalized (see <code><a href=\"#!/api/Ion.io-method-canonicalizePath\" rel=\"Ion.io-method-canonicalizePath\" class=\"docClass\">Ion.io.canonicalizePath</a>()</code>)</p>\n</div></li><li><span class='pre'>path</span> : String<div class='sub-desc'><p>The path to unzip the file into. <code>path</code> will be canonicalized (see <code><a href=\"#!/api/Ion.io-method-canonicalizePath\" rel=\"Ion.io-method-canonicalizePath\" class=\"docClass\">Ion.io.canonicalizePath</a>()</code>)</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>true if the operation succeeded, false if it failed.</p>\n</div></li></ul></div></div></div><div id='method-watchPath' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-method-watchPath' class='name expandable'>watchPath</a>( <span class='pre'>String path</span> ) : Boolean</div><div class='description'><div class='short'>Add a path to the list of watched directories (see Ion.io.watchedPaths and Ion.io.pathChanged). ...</div><div class='long'><p>Add a path to the list of watched directories (see <code><a href=\"#!/api/Ion.io-property-watchedPaths\" rel=\"Ion.io-property-watchedPaths\" class=\"docClass\">Ion.io.watchedPaths</a></code> and <code><a href=\"#!/api/Ion.io-event-pathChanged\" rel=\"Ion.io-event-pathChanged\" class=\"docClass\">Ion.io.pathChanged</a></code>).</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>path</span> : String<div class='sub-desc'><p>The path of the directory to watch.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p><code>true</code> if the path was successfully watched, <code>false</code> if not.</p>\n</div></li></ul></div></div></div><div id='method-writeFile' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-method-writeFile' class='name expandable'>writeFile</a>( <span class='pre'>String filePath, String/Number[] data, [Object options]</span> ) : Object</div><div class='description'><div class='short'>Writes data to the specified file as UTF-8 encoded text if data is a String, or as binary if data is a Number[]. ...</div><div class='long'><p>Writes data to the specified file as UTF-8 encoded text if <code>data</code> is a String, or as binary if <code>data</code> is a Number[].</p>\n\n<p>If the destination directory does not already exist, an attempt to create it will be made.</p>\n\n<pre><code>// Write our temp file that is storing cache\nvar result = <a href=\"#!/api/Ion.io-method-writeFile\" rel=\"Ion.io-method-writeFile\" class=\"docClass\">Ion.io.writeFile</a>(<a href=\"#!/api/Ion.io-property-tempPath\" rel=\"Ion.io-property-tempPath\" class=\"docClass\">Ion.io.tempPath</a> + 'MyApp.cache', JSON.stringify(cache));\nif (!result.success) {\n    alert('Failed to save cache!');\n}\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>filePath</span> : String<div class='sub-desc'><p>The path of the file which to write. <code>filePath</code> will be canonicalized (see <code><a href=\"#!/api/Ion.io-method-canonicalizePath\" rel=\"Ion.io-method-canonicalizePath\" class=\"docClass\">Ion.io.canonicalizePath</a>()</code>)</p>\n</div></li><li><span class='pre'>data</span> : String/Number[]<div class='sub-desc'><p>Either a text String or a Number[] (one Number per byte) of data to write to <code>filePath</code>.</p>\n</div></li><li><span class='pre'>options</span> : Object (optional)<div class='sub-desc'>\n<ul><li><span class='pre'>append</span> : Boolean (optional)<div class='sub-desc'><p><code>true</code> to append data to the end of the file, <code>false</code> to truncate the contents\nof the file. If <code>filePath</code> does not exist, then it will be created.</p>\n<p>Defaults to: <code>false</code></p></div></li></ul></div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>Returns an object with the following structure:</p>\n\n<ul>\n<li><code>success</code> : Boolean</li>\n</ul>\n\n</div></li></ul></div></div></div><div id='method-zip' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-method-zip' class='name expandable'>zip</a>( <span class='pre'>String filePath, String path, [Object options]</span> ) : Boolean</div><div class='description'><div class='short'>Zip a file. ...</div><div class='long'><p>Zip a file.</p>\n\n<pre><code>// Zip the contents of ~/myfolder into mydata.zip\n<a href=\"#!/api/Ion.io-method-zip\" rel=\"Ion.io-method-zip\" class=\"docClass\">Ion.io.zip</a>('mydata.zip', '~/myfolder');\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>filePath</span> : String<div class='sub-desc'><p>The path to where the zip file.</p>\n</div></li><li><span class='pre'>path</span> : String<div class='sub-desc'><p>The path to the contents to zip into <code>filePath</code>.</p>\n</div></li><li><span class='pre'>options</span> : Object (optional)<div class='sub-desc'><p>Optional parameters</p>\n<ul><li><span class='pre'>append</span> : Boolean (optional)<div class='sub-desc'><p>If true, the contents of <code>path</code> will be appended to <code>filePath</code>.</p>\n</div></li><li><span class='pre'>root</span> : String (optional)<div class='sub-desc'><p>Path to use as root. The root will be prepended to all of the paths in the zip file so that when the file is unzipped, all of the contents will be unzipped into a folder called <code>root</code>.</p>\n</div></li></ul></div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p>true if the operation succeeded, false if it failed.</p>\n</div></li></ul></div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-event'>Events</h3><div class='subsection'><div id='event-pathChanged' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.io'>Ion.io</span><br/></div><a href='#!/api/Ion.io-event-pathChanged' class='name expandable'>pathChanged</a>( <span class='pre'>String path, String file, Number changeType</span> )</div><div class='description'><div class='short'>Fired when a watched directory path has changed (see Ion.io.watchPath). ...</div><div class='long'><p>Fired when a watched directory path has changed (see <code><a href=\"#!/api/Ion.io-method-watchPath\" rel=\"Ion.io-method-watchPath\" class=\"docClass\">Ion.io.watchPath</a></code>).</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>path</span> : String<div class='sub-desc'><p>The path that has changed.</p>\n</div></li><li><span class='pre'>file</span> : String<div class='sub-desc'><p>The relative file path within <code>path</code> that caused the event to fire.</p>\n</div></li><li><span class='pre'>changeType</span> : Number<div class='sub-desc'><p>The type of change that occurred. The values and their meanings are as follows:</p>\n\n<ul>\n<li><code>1</code>: File Added</li>\n<li><code>2</code>: File Removed</li>\n<li><code>3</code>: File Modified</li>\n<li><code>4</code>: File Moved, Original Name</li>\n<li><code>5</code>: File Moved, New Name</li>\n</ul>\n\n</div></li></ul></div></div></div></div></div></div></div>","inheritdoc":null,"enum":null,"id":"class-Ion.io","mixedInto":[],"meta":{}});