Ext.data.JsonP.Ion_sys({"subclasses":[],"parentMixins":[],"aliases":{},"inheritable":null,"uses":[],"alternateClassNames":[],"html_meta":{},"override":null,"extends":null,"tagname":"class","requires":[],"files":[{"href":null,"filename":"Ion.sys.js"}],"superclasses":[],"singleton":true,"members":{"cfg":[],"method":[{"owner":"Ion.sys","tagname":"method","name":"exec","id":"method-exec","meta":{}},{"owner":"Ion.sys","tagname":"method","name":"getEnv","id":"method-getEnv","meta":{}}],"property":[{"owner":"Ion.sys","tagname":"property","name":"bitness","id":"property-bitness","meta":{"readonly":true}},{"owner":"Ion.sys","tagname":"property","name":"os","id":"property-os","meta":{"markdown":true,"readonly":true}}],"css_var":[],"event":[],"css_mixin":[]},"statics":{"cfg":[],"property":[],"method":[],"css_var":[],"event":[],"css_mixin":[]},"private":null,"component":false,"mixins":[],"name":"Ion.sys","linenr":1,"html":"<div><div class='doc-contents'><p>Provides system-level information and utility functions including the system <a href=\"#!/api/Ion.sys-property-bitness\" rel=\"Ion.sys-property-bitness\" class=\"docClass\">bitness</a> and\n<a href=\"#!/api/Ion.sys-property-os\" rel=\"Ion.sys-property-os\" class=\"docClass\">operating system</a>.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div id='property-bitness' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.sys'>Ion.sys</span><br/></div><a href='#!/api/Ion.sys-property-bitness' class='name expandable'>bitness</a><span> : Number</span><strong class='readonly signature' >readonly</strong></div><div class='description'><div class='short'>Returns the host system's bitness (32 or 64). ...</div><div class='long'><p>Returns the host system's bitness (32 or 64).</p>\n\n<pre><code>if (<a href=\"#!/api/Ion.sys-property-bitness\" rel=\"Ion.sys-property-bitness\" class=\"docClass\">Ion.sys.bitness</a> === 32) {\n    // Hmm, we only have 4 GB of addressable memory, better take it easy...\n    var arr = new Array(1024 * 1024 * 10);\n} else {\n    // Let's go to town!\n    var arr = new Array(1024 * 1024 * 1024 * 10);\n}\n</code></pre>\n</div></div></div><div id='property-os' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.sys'>Ion.sys</span><br/></div><a href='#!/api/Ion.sys-property-os' class='name expandable'>os</a><span> : String</span><strong class='readonly signature' >readonly</strong></div><div class='description'><div class='short'>Returns the host operating system, one of:\n\n\nmac\nwindows\nlinux\n\n\n\n\n\n\nvar root;\nif (Ion.sys.os === 'windows') {\n    ro...</div><div class='long'><p>Returns the host operating system, one of:</p>\n\n<ul>\n<li><code>mac</code></li>\n<li><code>windows</code></li>\n<li><code>linux</code></li>\n</ul>\n\n\n<!-- fool the duck -->\n\n\n<pre><code>var root;\nif (<a href=\"#!/api/Ion.sys-property-os\" rel=\"Ion.sys-property-os\" class=\"docClass\">Ion.sys.os</a> === 'windows') {\n    root = 'C:/';\n} else {\n    root = '/';\n}\n</code></pre>\n</div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-exec' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.sys'>Ion.sys</span><br/></div><a href='#!/api/Ion.sys-method-exec' class='name expandable'>exec</a>( <span class='pre'>String command, [String[] arguments]</span> ) : String</div><div class='description'><div class='short'>Starts a new process for command with the specified arguments, if any. ...</div><div class='long'><p>Starts a new process for <code>command</code> with the specified <code>arguments</code>, if any.</p>\n\n<pre><code>// List all files in the current working directory.\nif (<a href=\"#!/api/Ion.sys-property-os\" rel=\"Ion.sys-property-os\" class=\"docClass\">Ion.sys.os</a> === 'windows') {\n    console.log(<a href=\"#!/api/Ion.sys-method-exec\" rel=\"Ion.sys-method-exec\" class=\"docClass\">Ion.sys.exec</a>('dir'));\n} else {\n    console.log(<a href=\"#!/api/Ion.sys-method-exec\" rel=\"Ion.sys-method-exec\" class=\"docClass\">Ion.sys.exec</a>('ls -l'));\n}\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>command</span> : String<div class='sub-desc'>\n</div></li><li><span class='pre'>arguments</span> : String[] (optional)<div class='sub-desc'>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>Returns the standard output (stdout) from the command.</p>\n</div></li></ul></div></div></div><div id='method-getEnv' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.sys'>Ion.sys</span><br/></div><a href='#!/api/Ion.sys-method-getEnv' class='name expandable'>getEnv</a>( <span class='pre'>String name</span> ) : String</div><div class='description'><div class='short'>Gets the value of the specified environment variable. ...</div><div class='long'><p>Gets the value of the specified environment variable.</p>\n\n<pre><code>// Print out the current user's PATH.\nconsole.log(<a href=\"#!/api/Ion.sys-method-getEnv\" rel=\"Ion.sys-method-getEnv\" class=\"docClass\">Ion.sys.getEnv</a>('PATH'));\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : String<div class='sub-desc'><p>The case-insensitive name of the environment variable to retrieve.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>String</span><div class='sub-desc'><p>Returns the value of the specified environment variable, or an empty string if it does not exist.</p>\n</div></li></ul></div></div></div></div></div></div></div>","inheritdoc":null,"enum":null,"id":"class-Ion.sys","mixedInto":[],"meta":{}});