Ext.data.JsonP.Ion_ui_Menu({"subclasses":[],"parentMixins":[],"aliases":{},"inheritable":null,"uses":[],"alternateClassNames":[],"html_meta":{},"override":null,"extends":null,"tagname":"class","requires":[],"files":[{"href":null,"filename":"Ion.ui.Menu.js"}],"superclasses":[],"singleton":false,"members":{"cfg":[],"method":[{"owner":"Ion.ui.Menu","tagname":"method","name":"addMenu","id":"method-addMenu","meta":{}},{"owner":"Ion.ui.Menu","tagname":"method","name":"addMenuItem","id":"method-addMenuItem","meta":{}},{"owner":"Ion.ui.Menu","tagname":"method","name":"addSeparator","id":"method-addSeparator","meta":{}},{"owner":"Ion.ui.Menu","tagname":"method","name":"at","id":"method-at","meta":{"markdown":true}},{"owner":"Ion.ui.Menu","tagname":"method","name":"clear","id":"method-clear","meta":{}},{"owner":"Ion.ui.Menu","tagname":"method","name":"indexOf","id":"method-indexOf","meta":{}},{"owner":"Ion.ui.Menu","tagname":"method","name":"setEnabled","id":"method-setEnabled","meta":{}},{"owner":"Ion.ui.Menu","tagname":"method","name":"setText","id":"method-setText","meta":{}}],"property":[{"owner":"Ion.ui.Menu","tagname":"property","name":"enabled","id":"property-enabled","meta":{"readonly":true}},{"owner":"Ion.ui.Menu","tagname":"property","name":"length","id":"property-length","meta":{"readonly":true}},{"owner":"Ion.ui.Menu","tagname":"property","name":"text","id":"property-text","meta":{"readonly":true}}],"css_var":[],"event":[{"owner":"Ion.ui.Menu","tagname":"event","name":"aboutToHide","id":"event-aboutToHide","meta":{}},{"owner":"Ion.ui.Menu","tagname":"event","name":"aboutToShow","id":"event-aboutToShow","meta":{}}],"css_mixin":[]},"statics":{"cfg":[],"property":[],"method":[],"css_var":[],"event":[],"css_mixin":[]},"private":null,"component":false,"mixins":[],"name":"Ion.ui.Menu","linenr":1,"html":"<div><div class='doc-contents'><p>Represents a native application menu that is associated to a <a href=\"#!/api/Ion.ui.Window-property-menuBar\" rel=\"Ion.ui.Window-property-menuBar\" class=\"docClass\">window</a>'s <a href=\"#!/api/Ion.ui.MenuBar\" rel=\"Ion.ui.MenuBar\" class=\"docClass\">Ion.ui.MenuBar</a>\nor to another <a href=\"#!/api/Ion.ui.Menu\" rel=\"Ion.ui.Menu\" class=\"docClass\">Ion.ui.Menu</a>.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div id='property-enabled' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.Menu'>Ion.ui.Menu</span><br/></div><a href='#!/api/Ion.ui.Menu-property-enabled' class='name expandable'>enabled</a><span> : Boolean</span><strong class='readonly signature' >readonly</strong></div><div class='description'><div class='short'>Whether or not the menu is currently enabled. ...</div><div class='long'><p>Whether or not the menu is currently enabled.</p>\n\n<pre><code>// check the state of the menu\nif (myMenu.enabled) {\n   // do something interesting\n}\n</code></pre>\n</div></div></div><div id='property-length' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.Menu'>Ion.ui.Menu</span><br/></div><a href='#!/api/Ion.ui.Menu-property-length' class='name not-expandable'>length</a><span> : Number</span><strong class='readonly signature' >readonly</strong></div><div class='description'><div class='short'><p>The total number of menu items, separators &amp; menus in the menu.</p>\n</div><div class='long'><p>The total number of menu items, separators &amp; menus in the menu.</p>\n</div></div></div><div id='property-text' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.Menu'>Ion.ui.Menu</span><br/></div><a href='#!/api/Ion.ui.Menu-property-text' class='name expandable'>text</a><span> : String</span><strong class='readonly signature' >readonly</strong></div><div class='description'><div class='short'>The text of the menu item holding this menu. ...</div><div class='long'><p>The text of the menu item holding this menu.</p>\n\n<pre><code>var menu = Ion.ui.mainWindow.menuBar.addMenu('My Menu');\nconsole.log(menu.text);  // prints \"My Menu\"\n</code></pre>\n</div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-addMenu' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.Menu'>Ion.ui.Menu</span><br/></div><a href='#!/api/Ion.ui.Menu-method-addMenu' class='name expandable'>addMenu</a>( <span class='pre'>String text</span> ) : <a href=\"#!/api/Ion.ui.Menu\" rel=\"Ion.ui.Menu\" class=\"docClass\">Ion.ui.Menu</a></div><div class='description'><div class='short'>Create a new submenu with the specified label text, and append it to the end of the menu. ...</div><div class='long'><p>Create a new submenu with the specified label text, and append it to the end of the menu.</p>\n\n<p>This code:</p>\n\n<pre><code>var dataMenu = Ion.ui.mainWindow.menuBar.addMenu('Data'),\n    themeMenu,\n    catMenu;\n\ndataMenu.addMenuItem('Regenerate Data', function() {});\nthemeMenu = dataMenu.addMenu('Set Theme');\n\nthemeMenu.addMenuItem('Base', function() {});\nthemeMenu.addMenuItem('Green', function() {});\nthemeMenu.addMenuItem('Sky', function() {});\nthemeMenu.addMenuItem('Red', function() {});\nthemeMenu.addMenuItem('Purple', function() {});\nthemeMenu.addMenuItem('Blue', function() {});\nthemeMenu.addMenuItem('Yellow', function() {});\nvar catMenu = themeMenu.addMenu('Category');\n</code></pre>\n\n<p>Creates a menu like this:\n<p><img src=\"images/menu_submenu.png\" alt=\"\"></p></p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>text</span> : String<div class='sub-desc'><p>The title of the menu item that holds the submenu.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ion.ui.Menu\" rel=\"Ion.ui.Menu\" class=\"docClass\">Ion.ui.Menu</a></span><div class='sub-desc'><p>Returns the newly created submenu.</p>\n</div></li></ul></div></div></div><div id='method-addMenuItem' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.Menu'>Ion.ui.Menu</span><br/></div><a href='#!/api/Ion.ui.Menu-method-addMenuItem' class='name expandable'>addMenuItem</a>( <span class='pre'>String text, Function handler, [String shortcut]</span> ) : <a href=\"#!/api/Ion.ui.MenuItem\" rel=\"Ion.ui.MenuItem\" class=\"docClass\">Ion.ui.MenuItem</a></div><div class='description'><div class='short'>Create a new menu item with the specified label text, handler and\nkeyboard shortcut, and append it to the end of the ...</div><div class='long'><p>Create a new menu item with the specified label text, handler and\nkeyboard shortcut, and append it to the end of the menu.</p>\n\n<pre><code>// Add a simple menuItem with an anonymous handler function.\n// The handler function is also bound to 'Ctrl+S'.\nvar myMenu = Ion.ui.mainWindow.menuBar.addMenu('Sample');\nmyMenu.addMenuItem('Save', function() { alert('You Selected Save'); }, 'Ctrl+S');\n</code></pre>\n\n<p>Keyboard shortcut sequences are strings that dictate the key or\nkeys involved for the keyboard short. E.g.: \"Ctrl+C\", \"Del\", and\n\"Shift+Ctrl+S\".</p>\n\n<p><strong>Note for Mac OS X</strong></p>\n\n<p>On Mac OS X, Sencha Desktop Packager provides a menu bar merging feature to help\nconform with Mac OS X menu bar layout. If the <code>text</code> of a menu item starts with the string,\n\"About.\", that menu item will be placed at the beginning of the application menu. If the <code>text</code>\nof a menu item starts with the string, \"Preferences.\", that menu item will be placed in the\napplication menu.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>text</span> : String<div class='sub-desc'><p>The label to use on the new menu item.</p>\n</div></li><li><span class='pre'>handler</span> : Function<div class='sub-desc'><p>The callback function to be invoked when the menu item or shortcut is activated.</p>\n</div></li><li><span class='pre'>shortcut</span> : String (optional)<div class='sub-desc'><p>The string defining the keyboard shortcut (accelerator) to associate to the menu item.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ion.ui.MenuItem\" rel=\"Ion.ui.MenuItem\" class=\"docClass\">Ion.ui.MenuItem</a></span><div class='sub-desc'><p>Returns the newly created menu item.</p>\n</div></li></ul></div></div></div><div id='method-addSeparator' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.Menu'>Ion.ui.Menu</span><br/></div><a href='#!/api/Ion.ui.Menu-method-addSeparator' class='name expandable'>addSeparator</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Append a new separator to the end of the menu. ...</div><div class='long'><p>Append a new separator to the end of the menu.</p>\n\n<p>This code will generate a menu with separators between <code>Save</code> and <code>Save As</code>,\nbetween <code>Save As</code> and 'View Source<code>, and between</code>View Source<code>and</code>Exit`.</p>\n\n<pre><code>var fileMenu = Ion.ui.mainWindow.menuBar.addMenu('File');\n\nfileMenu.<a href=\"#!/api/Ion.ui.Menu-method-addMenuItem\" rel=\"Ion.ui.Menu-method-addMenuItem\" class=\"docClass\">addMenuItem</a>('Open', function() {});\nfileMenu.<a href=\"#!/api/Ion.ui.Menu-method-addMenuItem\" rel=\"Ion.ui.Menu-method-addMenuItem\" class=\"docClass\">addMenuItem</a>('Save', function() {});\nfileMenu.addSeparator();\nfileMenu.<a href=\"#!/api/Ion.ui.Menu-method-addMenuItem\" rel=\"Ion.ui.Menu-method-addMenuItem\" class=\"docClass\">addMenuItem</a>('Save As', function() {});\nfileMenu.addSeparator();\nfileMenu.<a href=\"#!/api/Ion.ui.Menu-method-addMenuItem\" rel=\"Ion.ui.Menu-method-addMenuItem\" class=\"docClass\">addMenuItem</a>('View Source', function() {});\nfileMenu.addSeparator();\nfileMenu.<a href=\"#!/api/Ion.ui.Menu-method-addMenuItem\" rel=\"Ion.ui.Menu-method-addMenuItem\" class=\"docClass\">addMenuItem</a>('Exit', function() {});\n</code></pre>\n\n<p><p><img src=\"images/menu_sep.png\" alt=\"\"></p></p>\n</div></div></div><div id='method-at' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.Menu'>Ion.ui.Menu</span><br/></div><a href='#!/api/Ion.ui.Menu-method-at' class='name expandable'>at</a>( <span class='pre'>Number index</span> ) : Object</div><div class='description'><div class='short'>Get the menu component at the specified index within the menu. ...</div><div class='long'><p>Get the menu component at the specified <code>index</code> within the menu.</p>\n\n<pre><code>var myMenu = Ion.ui.mainWindow.menuBar.addMenu('Menu'),\n    item;\nmyMenu.addMenuItem('MenuItem', function () {alert('MenuItem');});\nmyMenu.addSeparator();\nmyMenu.addMenu('SubMenu');\n\nconsole.log(myMenu.at(0));      // '[object <a href=\"#!/api/Ion.ui.MenuItem\" rel=\"Ion.ui.MenuItem\" class=\"docClass\">Ion.ui.MenuItem</a>]'\nconsole.log(myMenu.at(1));      // separator, prints 'undefined'\nconsole.log(myMenu.at(2).text); // 'SubMenu'\nconsole.log(myMenu.at(3));      // invalid index, prints 'undefined'\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>index</span> : Number<div class='sub-desc'><p>The zero based index of the menu component to return.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Object</span><div class='sub-desc'><p>Return the contents of the menu at the specified index:</p>\n\n<ul>\n<li>If index is invalid, return undefined.</li>\n<li>If item is a separator, return undefined.</li>\n<li>If item is a submenu, return its <a href=\"#!/api/Ion.ui.Menu\" rel=\"Ion.ui.Menu\" class=\"docClass\">Ion.ui.Menu</a>.</li>\n<li>If item is a menu item, return its <a href=\"#!/api/Ion.ui.MenuItem\" rel=\"Ion.ui.MenuItem\" class=\"docClass\">Ion.ui.MenuItem</a>.</li>\n</ul>\n\n\n<!-- fool the duck -->\n\n</div></li></ul></div></div></div><div id='method-clear' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.Menu'>Ion.ui.Menu</span><br/></div><a href='#!/api/Ion.ui.Menu-method-clear' class='name expandable'>clear</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Remove all menus/menu/separators items from the menu, which also unsubscribes any applicable keyboard shortcuts. ...</div><div class='long'><p>Remove all menus/menu/separators items from the menu, which also unsubscribes any applicable keyboard shortcuts.</p>\n\n<pre><code>var myMenu = Ion.ui.mainWindow.menuBar.addMenu('myMenu');\n\n// Add some menu items to a menu...\nmyMenu.<a href=\"#!/api/Ion.ui.Menu-method-addMenuItem\" rel=\"Ion.ui.Menu-method-addMenuItem\" class=\"docClass\">addMenuItem</a>('menu item', function(){});\n\n// Decide you don't want them any more (for example, to switch to a different menu structure)\nmyMenu.clear();\n// Poof! All gone!\n</code></pre>\n</div></div></div><div id='method-indexOf' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.Menu'>Ion.ui.Menu</span><br/></div><a href='#!/api/Ion.ui.Menu-method-indexOf' class='name expandable'>indexOf</a>( <span class='pre'></span> ) : Number</div><div class='description'><div class='short'>Get the index of the specified Ion.ui.MenuItem or Ion.ui.Menu within the\nmenu. ...</div><div class='long'><p>Get the index of the specified <a href=\"#!/api/Ion.ui.MenuItem\" rel=\"Ion.ui.MenuItem\" class=\"docClass\">Ion.ui.MenuItem</a> or <a href=\"#!/api/Ion.ui.Menu\" rel=\"Ion.ui.Menu\" class=\"docClass\">Ion.ui.Menu</a> within the\nmenu.</p>\n\n<pre><code>var menu = Ion.ui.mainWindow.menuBar.addMenu('menu'),\n    item0 = menu.addMenuItem('item0', function () {}),\n    item1 = menu.addMenuItem('item1', function () {}),\n    item2 = menu.addMenuItem('item2', function () {}),\n    submenu = menu.addMenu('submenu'),\n    othermenu = Ion.ui.mainWindow.menuBar.addMenu('other menu');\n\nconsole.log(menu.indexOf(item1));      // 1\nconsole.log(menu.indexOf(submenu));    // 3\nconsole.log(othermenu.indexOf(item1)); // undefined\nconsole.log(menu.indexOf(othermenu));  // undefined\n</code></pre>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>The zero based index of the item, or <code>undefined</code> if the item is not found\nin the menu.</p>\n</div></li></ul></div></div></div><div id='method-setEnabled' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.Menu'>Ion.ui.Menu</span><br/></div><a href='#!/api/Ion.ui.Menu-method-setEnabled' class='name expandable'>setEnabled</a>( <span class='pre'>Boolean enabled</span> )</div><div class='description'><div class='short'>If enabled is true, the menu becomes enabled, else it is disabled. ...</div><div class='long'><p>If <code>enabled</code> is <code>true</code>, the menu becomes enabled, else it is disabled.</p>\n\n<pre><code>var data = { isModified: false },\n    menu = Ion.ui.mainWindow.menuBar.addMenu('Menu'),\n    saveOptions = menu.addMenuItem('Save Options', function(){console.log('saving...')});\n\n// Turn off the 'Save Options...' menu, unless something needs to be saved.\nif (data.isModified) {\n   saveOptions.setEnabled(true);\n} else {\n   saveOptions.setEnabled(false);\n}\n\n// or in short form\nsaveOptions.setEnabled(data.isModified);\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>enabled</span> : Boolean<div class='sub-desc'><p><code>true</code> to enable, <code>false</code> to disable.</p>\n</div></li></ul></div></div></div><div id='method-setText' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.Menu'>Ion.ui.Menu</span><br/></div><a href='#!/api/Ion.ui.Menu-method-setText' class='name expandable'>setText</a>( <span class='pre'>String text</span> )</div><div class='description'><div class='short'>Set the text of the item that holds the submenu. ...</div><div class='long'><p>Set the text of the item that holds the submenu.</p>\n\n<pre><code>var menu = Ion.ui.mainWindow.menuBar.addMenu('Menu'),\n    submenu = menu.addMenu('Sub Menu');\n\nmenu.setText('New Label');\nsubmenu.setText('Sub Menu *');\n\nconsole.log(menu.text);    // 'New Label'\nconsole.log(submenu.text); // 'Sub Menu *'\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>text</span> : String<div class='sub-desc'><p>The new label for the menu.</p>\n</div></li></ul></div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-event'>Events</h3><div class='subsection'><div id='event-aboutToHide' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.Menu'>Ion.ui.Menu</span><br/></div><a href='#!/api/Ion.ui.Menu-event-aboutToHide' class='name expandable'>aboutToHide</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Fired when the menu is about to be hidden. ...</div><div class='long'><p>Fired when the menu is about to be hidden.</p>\n</div></div></div><div id='event-aboutToShow' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.Menu'>Ion.ui.Menu</span><br/></div><a href='#!/api/Ion.ui.Menu-event-aboutToShow' class='name expandable'>aboutToShow</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Fired when the menu is about to be shown. ...</div><div class='long'><p>Fired when the menu is about to be shown. This event can be used to set a menu according to context.</p>\n\n<p><strong>Note</strong> If an empty menu is selected, <code>aboutToShow</code> will fire but the menu will not be displayed. When\nusing aboutToShow to populate a menu before displaying it, be sure the menu is not empty by adding\ndefault items or a separator when the menu is created.</p>\n\n<pre><code>var menu = Ion.ui.mainWindow.menuBar.addMenu('Choose Color'),\n    color_scheme = 'warm';\n\n// initialize the menu with a separator to make sure it shows the first time\nmenu.addSeparator();\n\nmenu.aboutToShow.connect(function () {\n    menu.clear();\n    if (color_scheme === 'warm') {\n        menu.addMenuItem('Red', function() {});\n        menu.addMenuItem('Orange', function() {});\n        menu.addMenuItem('Yellow', function() {});\n        color_scheme = 'cool';\n    }\n    else {\n        menu.addMenuItem('Green', function() {});\n        menu.addMenuItem('Blue', function() {});\n        menu.addMenuItem('Purple', function() {});\n        color_scheme = 'warm';\n    }\n});\n\n// At this point, opening and closing the menu will\n// change its contents\n</code></pre>\n</div></div></div></div></div></div></div>","inheritdoc":null,"enum":null,"id":"class-Ion.ui.Menu","mixedInto":[],"meta":{}});