Ext.data.JsonP.Ion_ui_MenuBar({"subclasses":[],"parentMixins":[],"aliases":{},"inheritable":null,"uses":[],"alternateClassNames":[],"html_meta":{},"override":null,"extends":null,"tagname":"class","requires":[],"files":[{"href":null,"filename":"Ion.ui.MenuBar.js"}],"superclasses":[],"singleton":false,"members":{"cfg":[],"method":[{"owner":"Ion.ui.MenuBar","tagname":"method","name":"addMenu","id":"method-addMenu","meta":{}},{"owner":"Ion.ui.MenuBar","tagname":"method","name":"at","id":"method-at","meta":{}},{"owner":"Ion.ui.MenuBar","tagname":"method","name":"clear","id":"method-clear","meta":{}},{"owner":"Ion.ui.MenuBar","tagname":"method","name":"indexOf","id":"method-indexOf","meta":{}}],"property":[{"owner":"Ion.ui.MenuBar","tagname":"property","name":"length","id":"property-length","meta":{"readonly":true}}],"css_var":[],"event":[],"css_mixin":[]},"statics":{"cfg":[],"property":[],"method":[],"css_var":[],"event":[],"css_mixin":[]},"private":null,"component":false,"mixins":[],"name":"Ion.ui.MenuBar","linenr":1,"html":"<div><div class='doc-contents'><p>Represents a native application menu that is associated to an <a href=\"#!/api/Ion.ui.Window\" rel=\"Ion.ui.Window\" class=\"docClass\">Ion.ui.Window</a>. This menu is typically\ndocked at the top of the window (Windows or Linux) or is shown at the top menu bar when the window is active\n(Mac OS X).</p>\n\n<p>The menu bar can be accessed for a given <a href=\"#!/api/Ion.ui.Window\" rel=\"Ion.ui.Window\" class=\"docClass\">Ion.ui.Window</a> via <a href=\"#!/api/Ion.ui.Window-property-menuBar\" rel=\"Ion.ui.Window-property-menuBar\" class=\"docClass\">Ion.ui.Window.menuBar</a>.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div id='property-length' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.MenuBar'>Ion.ui.MenuBar</span><br/></div><a href='#!/api/Ion.ui.MenuBar-property-length' class='name not-expandable'>length</a><span> : Object</span><strong class='readonly signature' >readonly</strong></div><div class='description'><div class='short'><p>The total number of menus in the menubar.</p>\n</div><div class='long'><p>The total number of menus in the menubar.</p>\n</div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-addMenu' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.MenuBar'>Ion.ui.MenuBar</span><br/></div><a href='#!/api/Ion.ui.MenuBar-method-addMenu' class='name expandable'>addMenu</a>( <span class='pre'>String text</span> ) : <a href=\"#!/api/Ion.ui.Menu\" rel=\"Ion.ui.Menu\" class=\"docClass\">Ion.ui.Menu</a></div><div class='description'><div class='short'>Create a new submenu with the specified label text, and append it to the end of the menu bar. ...</div><div class='long'><p>Create a new submenu with the specified label text, and append it to the end of the menu bar.</p>\n\n<pre><code>// Add a submenu to the main window's main menu bar.\nfunction handleChooseBlue(item) { console.log('Blue'); }\nfunction handleChooseRed(item) { console.log('Red'); }\n\nvar submenu = Ion.ui.mainWindow.menuBar.addMenu('Choose Color');\nsubmenu.<a href=\"#!/api/Ion.ui.Menu-method-addMenuItem\" rel=\"Ion.ui.Menu-method-addMenuItem\" class=\"docClass\">addMenuItem</a>('Blue', handleChooseBlue, 'Ctrl+B');\nsubmenu.<a href=\"#!/api/Ion.ui.Menu-method-addMenuItem\" rel=\"Ion.ui.Menu-method-addMenuItem\" class=\"docClass\">addMenuItem</a>('Red', handleChooseRed, 'Ctrl+R');\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>text</span> : String<div class='sub-desc'><p>The label text of the menu item that holds the submenu.</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ion.ui.Menu\" rel=\"Ion.ui.Menu\" class=\"docClass\">Ion.ui.Menu</a></span><div class='sub-desc'><p>Returns the newly created submenu.</p>\n</div></li></ul></div></div></div><div id='method-at' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.MenuBar'>Ion.ui.MenuBar</span><br/></div><a href='#!/api/Ion.ui.MenuBar-method-at' class='name expandable'>at</a>( <span class='pre'>Number index</span> ) : <a href=\"#!/api/Ion.ui.Menu\" rel=\"Ion.ui.Menu\" class=\"docClass\">Ion.ui.Menu</a></div><div class='description'><div class='short'>Get the submenu at the specified index within the menu bar. ...</div><div class='long'><p>Get the submenu at the specified <code>index</code> within the menu bar.</p>\n\n<pre><code>// iterate over menus in menubar\nvar menubar = Ion.ui.mainWindow.menuBar,\n    length = menubar.length,\n    i = 0,\n    submenu;\n\nwhile (i &lt; length) {\n    submenu = menubar.at(i);\n    console.log(i + ': \\'' + submenu.text + '\\'');\n    i = i + 1;\n}\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>index</span> : Number<div class='sub-desc'><p>The zero based index of the menu item to return. On platforms like OS X,\nwhere there are system maintained items in the menubar, the zero index will reference the first\nmenu added with <a href=\"#!/api/Ion.ui.MenuBar-method-addMenu\" rel=\"Ion.ui.MenuBar-method-addMenu\" class=\"docClass\">Ion.ui.MenuBar.addMenu</a>().</p>\n</div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'><a href=\"#!/api/Ion.ui.Menu\" rel=\"Ion.ui.Menu\" class=\"docClass\">Ion.ui.Menu</a></span><div class='sub-desc'><p>Return the submenu requested, or <code>undefined</code> if <code>index</code> is invalid.</p>\n</div></li></ul></div></div></div><div id='method-clear' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.MenuBar'>Ion.ui.MenuBar</span><br/></div><a href='#!/api/Ion.ui.MenuBar-method-clear' class='name expandable'>clear</a>( <span class='pre'></span> )</div><div class='description'><div class='short'>Remove all menus/menu items from the menu, which also unsubscribes any applicable keyboard shortcuts. ...</div><div class='long'><p>Remove all menus/menu items from the menu, which also unsubscribes any applicable keyboard shortcuts.</p>\n\n<pre><code>// Add some submenus to the menuBar...\nvar i = 1;\nwhile (i &lt;= 5) {\n  Ion.ui.mainWindow.menuBar.addMenu('menu ' + i);\n  i++;\n}\n\n// Decide you don't want them any more (for example, to switch to a different menu structure)\nIon.ui.mainWindow.menuBar.clear();\n// Poof! All gone!\n</code></pre>\n</div></div></div><div id='method-indexOf' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.MenuBar'>Ion.ui.MenuBar</span><br/></div><a href='#!/api/Ion.ui.MenuBar-method-indexOf' class='name expandable'>indexOf</a>( <span class='pre'></span> ) : Number</div><div class='description'><div class='short'>Get the index of the specified Ion.ui.Menu within the\nmenu. ...</div><div class='long'><p>Get the index of the specified <a href=\"#!/api/Ion.ui.Menu\" rel=\"Ion.ui.Menu\" class=\"docClass\">Ion.ui.Menu</a> within the\nmenu.</p>\n\n<pre><code>var menubar = Ion.ui.mainWindow.menuBar,\n    menu = menubar.addMenu('menu'),\n    othermenu = menubar.addMenu('other menu'),\n    submenu  = menu.addMenu('submenu');\n\nconsole.log(menubar.indexOf(menu));      // 0\nconsole.log(menubar.indexOf(othermenu)); // 1\nconsole.log(menubar.indexOf(submenu));   // undefined\n</code></pre>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Number</span><div class='sub-desc'><p>The zero based index of the menu, or <code>undefined</code> if the menu is not found\nin the menubar.</p>\n</div></li></ul></div></div></div></div></div></div></div>","inheritdoc":null,"enum":null,"id":"class-Ion.ui.MenuBar","mixedInto":[],"meta":{}});