Ext.data.JsonP.Ion_ui_MenuItem({"subclasses":[],"parentMixins":[],"aliases":{},"inheritable":null,"uses":[],"alternateClassNames":[],"html_meta":{},"override":null,"extends":null,"tagname":"class","requires":[],"files":[{"href":null,"filename":"Ion.ui.MenuItem.js"}],"superclasses":[],"singleton":false,"members":{"cfg":[],"method":[{"owner":"Ion.ui.MenuItem","tagname":"method","name":"setEnabled","id":"method-setEnabled","meta":{}},{"owner":"Ion.ui.MenuItem","tagname":"method","name":"setText","id":"method-setText","meta":{}}],"property":[{"owner":"Ion.ui.MenuItem","tagname":"property","name":"enabled","id":"property-enabled","meta":{"readonly":true}},{"owner":"Ion.ui.MenuItem","tagname":"property","name":"handle","id":"property-handle","meta":{"readonly":true,"private":true}},{"owner":"Ion.ui.MenuItem","tagname":"property","name":"text","id":"property-text","meta":{"readonly":true}}],"css_var":[],"event":[],"css_mixin":[]},"statics":{"cfg":[],"property":[],"method":[],"css_var":[],"event":[],"css_mixin":[]},"private":null,"component":false,"mixins":[],"name":"Ion.ui.MenuItem","linenr":1,"html":"<div><div class='doc-contents'><p>Represents an item in a <a href=\"#!/api/Ion.ui.Menu\" rel=\"Ion.ui.Menu\" class=\"docClass\">Ion.ui.Menu</a>.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div id='property-enabled' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.MenuItem'>Ion.ui.MenuItem</span><br/></div><a href='#!/api/Ion.ui.MenuItem-property-enabled' class='name expandable'>enabled</a><span> : Boolean</span><strong class='readonly signature' >readonly</strong></div><div class='description'><div class='short'>Whether or not the menu item is currently enabled. ...</div><div class='long'><p>Whether or not the menu item is currently enabled.</p>\n\n<pre><code>// check the state of menuItem\nif (myMenuItem.enabled) {\n   console.log('Window is minimized');\n}\n</code></pre>\n</div></div></div><div id='property-handle' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.MenuItem'>Ion.ui.MenuItem</span><br/></div><a href='#!/api/Ion.ui.MenuItem-property-handle' class='name expandable'>handle</a><span> : Number</span><strong class='private signature' >private</strong><strong class='readonly signature' >readonly</strong></div><div class='description'><div class='short'>Unique id for the menu item. ...</div><div class='long'><p>Unique id for the menu item.</p>\n\n<p>This is an internal property that is implementation specific. It is not officially supported.\nIts usage and existance are not guaranteed in future releases.</p>\n</div></div></div><div id='property-text' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.MenuItem'>Ion.ui.MenuItem</span><br/></div><a href='#!/api/Ion.ui.MenuItem-property-text' class='name expandable'>text</a><span> : String</span><strong class='readonly signature' >readonly</strong></div><div class='description'><div class='short'>The text/label of the menu item. ...</div><div class='long'><p>The text/label of the menu item.</p>\n\n<pre><code>// handleMenuItem is a callback function which can be shared between\n// several menu items, and uses the name of the menuItem to decide which\n// menuItem has been activated.\nvar handleMenuItem =\n    function(item) {\n      switch (item.text) {\n        case 'Left':\n           console.log('Left');\n           break;\n        case 'Right':\n           console.log('Right');\n           break;\n       }\n    },\n    menu = Ion.ui.mainWindow.menuBar.addMenu('example');\n\nmenu.addMenuItem('Left', handleMenuItem);\nmenu.addMenuItem('Right', handleMenuItem);\n</code></pre>\n</div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-setEnabled' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.MenuItem'>Ion.ui.MenuItem</span><br/></div><a href='#!/api/Ion.ui.MenuItem-method-setEnabled' class='name expandable'>setEnabled</a>( <span class='pre'>Boolean enabled</span> )</div><div class='description'><div class='short'>If enabled is true, the menu item becomes enabled, else it is disabled. ...</div><div class='long'><p>If <code>enabled</code> is <code>true</code>, the menu item becomes enabled, else it is disabled.</p>\n\n<pre><code>var data = { isModified: true },\n    menu = Ion.ui.mainWindow.menuBar.addMenu('Example'),\n    saveItem = menu.addMenuItem('Save', function (item) {});\n\n// Turn off the 'Save' menu item, unless something needs to be saved.\nsaveItem.setEnabled(data.isModified);\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>enabled</span> : Boolean<div class='sub-desc'><p><code>true</code> to enable, <code>false</code> to disable.</p>\n</div></li></ul></div></div></div><div id='method-setText' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.ui.MenuItem'>Ion.ui.MenuItem</span><br/></div><a href='#!/api/Ion.ui.MenuItem-method-setText' class='name expandable'>setText</a>( <span class='pre'>String text</span> )</div><div class='description'><div class='short'>Set the text of the menuitem. ...</div><div class='long'><p>Set the text of the menuitem.</p>\n\n<pre><code>var menu = Ion.ui.mainWindow.menuBar.addMenu('Menu'),\n    menuitem = menu.addMenuItem('Item', function ()  {alert('Item');}, 'Ctrl+S');\n\nmenuitem.setText('New Text');\nconsole.log(menuitem.text); // 'New Text'\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>text</span> : String<div class='sub-desc'><p>The new label for the menuitem.</p>\n</div></li></ul></div></div></div></div></div></div></div>","inheritdoc":null,"enum":null,"id":"class-Ion.ui.MenuItem","mixedInto":[],"meta":{}});