Ext.data.JsonP.Ion_util({"subclasses":[],"parentMixins":[],"aliases":{},"inheritable":null,"uses":[],"alternateClassNames":[],"html_meta":{},"override":null,"extends":null,"tagname":"class","requires":[],"files":[{"href":null,"filename":"Ion.util.js"}],"superclasses":[],"singleton":true,"members":{"cfg":[],"method":[{"owner":"Ion.util","tagname":"method","name":"openUrl","id":"method-openUrl","meta":{"markdown":true}},{"owner":"Ion.util","tagname":"method","name":"takeScreenshot","id":"method-takeScreenshot","meta":{}}],"property":[],"css_var":[],"event":[],"css_mixin":[]},"statics":{"cfg":[],"property":[],"method":[],"css_var":[],"event":[],"css_mixin":[]},"private":null,"component":false,"mixins":[],"name":"Ion.util","linenr":2,"html":"<div><div class='doc-contents'><p>Collection of utility functions.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-openUrl' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.util'>Ion.util</span><br/></div><a href='#!/api/Ion.util-method-openUrl' class='name expandable'>openUrl</a>( <span class='pre'></span> ) : Boolean</div><div class='description'><div class='short'>Open a URL in its default handler program, as decided by the operating system. ...</div><div class='long'><p>Open a URL in its default handler program, as decided by the operating system. E.g.:</p>\n\n<ul>\n<li>http: => Web Browser</li>\n<li>mailto: => Mail Client</li>\n<li>file: => Default Program for the File's Type</li>\n</ul>\n\n\n<!-- fool the duck -->\n\n\n<pre><code>// Compose a new email message with a subject of \"Greetings Earthling!\"\n<a href=\"#!/api/Ion.util-method-openUrl\" rel=\"Ion.util-method-openUrl\" class=\"docClass\">Ion.util.openUrl</a>('mailto:?subject=Greetings%20Earthling!');\n</code></pre>\n<h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p><code>true</code> if the URL was successfully opened, <code>false</code> if not.</p>\n</div></li></ul></div></div></div><div id='method-takeScreenshot' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='Ion.util'>Ion.util</span><br/></div><a href='#!/api/Ion.util-method-takeScreenshot' class='name expandable'>takeScreenshot</a>( <span class='pre'>String filePath, [Object options]</span> ) : Boolean</div><div class='description'><div class='short'>Capture all or a portion of the application window and save as a png file. ...</div><div class='long'><p>Capture all or a portion of the application window and save as a png file.</p>\n\n<pre><code>var path = <a href=\"#!/api/Ion.io-property-userDocsPath\" rel=\"Ion.io-property-userDocsPath\" class=\"docClass\">Ion.io.userDocsPath</a> + 'screenshot.png';\n\n// Capture the entire window.\n<a href=\"#!/api/Ion.util-method-takeScreenshot\" rel=\"Ion.util-method-takeScreenshot\" class=\"docClass\">Ion.util.takeScreenshot</a>(path);\n\n// Capture the part of the window to the right of and below (15, 25)\n<a href=\"#!/api/Ion.util-method-takeScreenshot\" rel=\"Ion.util-method-takeScreenshot\" class=\"docClass\">Ion.util.takeScreenshot</a>(path, {x: 15, y: 25});\n\n// Capture a 100 x 200 portion of the window starting at (0, 0)\n<a href=\"#!/api/Ion.util-method-takeScreenshot\" rel=\"Ion.util-method-takeScreenshot\" class=\"docClass\">Ion.util.takeScreenshot</a>(path, {width: 100, height: 200});\n\n// Capture a 100 x 200 portion of the window starting at (50, 50)\n<a href=\"#!/api/Ion.util-method-takeScreenshot\" rel=\"Ion.util-method-takeScreenshot\" class=\"docClass\">Ion.util.takeScreenshot</a>(path, {x: 50, y: 50, width: 100, height: 200});\n</code></pre>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>filePath</span> : String<div class='sub-desc'><p>Path to the file where the screenshot should be saved. If any directories in <code>filePath</code> are missing, they will be created. <code>filePath</code> will be canonicalized (see <code><a href=\"#!/api/Ion.io-method-canonicalizePath\" rel=\"Ion.io-method-canonicalizePath\" class=\"docClass\">Ion.io.canonicalizePath</a>()</code>)</p>\n</div></li><li><span class='pre'>options</span> : Object (optional)<div class='sub-desc'><p>Object containing the following options:</p>\n<ul><li><span class='pre'>x</span> : Number (optional)<div class='sub-desc'><p>The x offset of the window rectangle to capture. Defaults to 0 (zero).</p>\n</div></li><li><span class='pre'>y</span> : Number (optional)<div class='sub-desc'><p>The y offset of the window rectangle to capture. Defaults to 0 (zero).</p>\n</div></li><li><span class='pre'>width</span> : Number (optional)<div class='sub-desc'><p>The width of the window rectangle to capture. Defaults to window width - x.</p>\n</div></li><li><span class='pre'>height</span> : Number (optional)<div class='sub-desc'><p>The height of the window rectangle to capture. Defaults to window height - y.</p>\n\n<p>Note that if only <code>x</code> and / or <code>y</code> are specified, the entire screen to the right and below <code>x, y</code> will be captured.\nIf no position or size is specified, the entire window will be captured.</p>\n</div></li></ul></div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>Boolean</span><div class='sub-desc'><p><code>true</code> if the screen shot is successfully captured to <code>filePath</code>.</p>\n</div></li></ul></div></div></div></div></div></div></div>","inheritdoc":null,"enum":null,"id":"class-Ion.util","mixedInto":[],"meta":{}});